/*----------------------------------------------------------------------
                                                                        
              Inclusion of system functions                             
                                                                       
*-----------------------------------------------------------------------*/
#include <stdio.h> 
#include <stdlib.h> 
#include <math.h>
#include <string.h>
#include <stdarg.h>
 
#include <values.h>
 
#include "GraphicsGems.h"
#include "/usr/local/include/tdm/tdm.h"

#ifdef SINGLE
#define REAL float
#else /* not SINGLE */ 
#define REAL double
#endif /* not SINGLE */

/*-----------------------------------------------------------------
  
    Declaracao de Variaveis, Tipos e Estruturas usadas para 
    gerar um objeto 3D usando a biblioteca TDM
 
 ----------------------------------------------------------------*/
typedef struct {
    int nro;
    int corresp[1000];
}Candidatos;
  
typedef struct { 
  Point3 p1,p2;
} Pair;

typedef struct { 
  int i,j; 
}Indice;

typedef struct {
  int id_face;
  Point3 B;
  Point3 N;
  double area;
}Faces;

typedef struct {
  int i,j,k; 
}Indice3;

typedef struct {
  int i,j,k,l; 
}Indice2;


typedef float Quaternion[4];

typedef struct { 
  Point3 X;             // coordenadas geometrica dos vertices
  Point3 X_orig;
  Indice indI;          // indice do pto_corresp assoc.       
  int borda;             // ponto associado com a borda do modelo.
  int item;
  double curvmin;
  double curvmax;
  Point3 normal;
  int indi[3];
} Vertice;

typedef struct {
  int ind[3];            // index dos vertices
  int borda;        // 1 = uma aresta borda  2 = duas a.b. 
  int face_prox;
  int item;
  Point3 B;
  Point3 N;
} Face;

typedef struct imag_cart {
  Indice ind;
  Point3 X;
  Point3 X_orig; /* Amostra original */
  Point3 normal; /* Normal da face associada */
  Point3 pto_ext;
  int pto_mdl; // 1 = there is a corresponding point;
  int id_face;
  double dist;
  int borda; // 0=Nao eh da borda e 1,2,... = Indica numero borda interior
  int misto; 
  int redund;
} Img_cart;

struct referencial {
  Vector3 x;
  Vector3 y;
  Vector3 z;
} cur_ref;  

struct Listdist{
  double d;
  int i;
  struct Listdist *ant;
  struct Listdist *prox;
};

typedef struct{
  REAL *pointlist;                                               /* In / out */
  REAL *pointattributelist;                                      /* In / out */
  int *pointmarkerlist;                                          /* In / out */
  int numberofpoints;                                            /* In / out */
  int numberofpointattributes;                                   /* In / out */

  int *trianglelist;                                             /* In / out */
  REAL *triangleattributelist;                                   /* In / out */
  REAL *trianglearealist;                                         /* In only */
  int *neighborlist;                                             /* Out only */
  int numberoftriangles;                                         /* In / out */
  int numberofcorners;                                           /* In / out */
  int numberoftriangleattributes;                                /* In / out */

  int *segmentlist;                                              /* In / out */
  int *segmentmarkerlist;                                        /* In / out */
  int numberofsegments;                                          /* In / out */

  REAL *holelist;                        /* In / pointer to array copied out */
  int numberofholes;                                      /* In / copied out */

  REAL *regionlist;                      /* In / pointer to array copied out */
  int numberofregions;                                    /* In / copied out */

  int *edgelist;                                                 /* Out only */
  int *edgemarkerlist;            /* Not used with Voronoi diagram; out only */
  REAL *normlist;                /* Used only with Voronoi diagram; out only */
  int numberofedges;                                             /* Out only */
} Trian;

/*------------------------------------------------------*/


