/*-----------------------------------------------------------------------
  Metodo de Pre-alinhamento de Duas Imagens.  2008 - DCA/FEEC/UNICAMP/SP/BR

   ENTRADA:
  (1) Duas imagens de profundidade de formato txt, rif ou ply
  SAIDA: 
-------------------------------------------------------------------------*/
#include "estrut.h"
#include <stdio.h>
#include <math.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_eigen.h>
#include <gsl/gsl_sort.h>
#include <gsl/gsl_statistics.h>
#include <gsl/gsl_eigen.h>
#include <gsl/gsl_combination.h>

#define PI              3.14159265358979323846   /* the venerable pi */
#define RED1 0.2
/*Variaveis Globais 				        
--------------------------------------------------------------*/
extern double Int[2], Int2[2], erros[2], maxInts[2];
extern double Tolreg, Tolsimp;
Vertice **vertices;
Face **faces;
Indice *nvertfacessimp;
int array_flag[670][670];
extern int ply, rif, txt, nvi, *X_MAX, *Y_MAX, nfacesdensa[2];
extern double *raio,*raiomenor,*raiomeio;
int nro_ve[2], mediox,medioy,Obj;
extern char **imagem;
double cx_mod,cy_mod,cz_mod,xmin,xMax,ymin,yMax,zmin,zMax,Eps=FLT_EPSILON;
Matrix4 transf_mat, transf_mat_inv, transl_orig,transl_orig_inv,R0;
int FIMMDL=0, iteracao=0, NUM_PTOS[2];
Img_cart *array_orig[2][670][670];
extern Matrix4 R[3];
/***********************************************************************
	     Funcoes de outros modulos
***********************************************************************/
void mesh_to_image(Matrix4 ,Point3 ,Point3 *);
int coord_baryc(Point2 *,Point2 *,Point2 *,Point2 *,double *,double *,double *);int coord_barycentric3(Point3 *, Point3 *, Point3 *, Point3 *,double *,
                       double *, double *);
void init_pairs(void);
void add_pair(Point3, Point3 );
void indice_para_ponto_dist_registro (Point3 ,Indice *);
void indice_para_ponto_dist_registro3 (Point3 ,Indice *);
/************************************************************************
                    Funcoes do Modulo
*************************************************************************/
int check_alig2(Matrix4, Faces *, int, int *, int, int *);
void le_e_escreve_arquivos(void);
void cria_malhas_densas_smfeply(void);
void simplifica_malha_densa_smf(void);
void gera_mapa_curvatura(void);
void associa_normal_amostra(void);
void determina_normal_vertices (int);
void determina_array_flag(float );
int mede_erro_amostras(Matrix4, int *,int *);
int mede_erro_faces (Matrix4, Faces *, int , int *, int, int *, int *);
int check_alig_malha(Matrix4, Faces *, int ,double *, double, int *);
int check_alig_malha2(Matrix4, Faces *,int,int *,int,double *, double, int *);
int le_imagem(void);
void getimageint(void );
void nome_image(void);
void registro(void);
void match_pairs(Matrix4 *, int, Quaternion *, Point3 *);
void convert_quat_to_mat(Quaternion , Matrix4 *);
void casamento_triedros(void);
void update_mesh(Matrix4);
int check_align2(Matrix4, Point3 *, int, int *, int, int *);
void retrieve_mesh(void);
int mesmo_normal(int **, int **, Point3 **, Point3, Point3 *, int, int *,
                 int *,int *, int*);
void acha_normal(Point3 *, int, Point3 *);
void normaliza_arestas(Point3 *, Point3 , int);

void nome_image(){
  /* Le a imagem nvi-1 */
  rif=txt=ply=0; 
  
  imagem = (char**) realloc(imagem,sizeof(char*)*nvi);
  imagem[nvi-1] = (char*) malloc(30*sizeof(char));
  
  //  strcpy(imagem[nvi-1],"banana.oogl_scale150051.rif");
    strcpy(imagem[nvi-1],"machine.oogl_scale150005.rif");
    strcpy(imagem[nvi-1],"angel-deg40.txt");
    strcpy(imagem[nvi-1],"bluedino36.txt");
    strcpy(imagem[nvi-1],"hub.oogl_scale150009.rif");
    strcpy(imagem[nvi-1],"teletubby-deg60.txt");
    strcpy(imagem[nvi-1],"happyStand48.txt");
    strcpy(imagem[nvi-1],"pitt.oogl_scale150019.rif");
    strcpy(imagem[nvi-1],"club.oogl_scale150023.rif"); 
    //strcpy(imagem[nvi-1],"pitt.oogl_scale150018.rif");
    //    strcpy(imagem[nvi-1],"frog-deg120.txt");
    //    strcpy(imagem[nvi-1],"pitbull.oogl_scale150028.rif");
    
        strcpy(imagem[nvi-1],"bunny90.txt");
    //    strcpy(imagem[nvi-1],"frog-deg180.txt");
    //    strcpy(imagem[nvi-1],"pitt.oogl_scale150023.rif");
    
  //scanf ("%s",&(imagem[nvi-1]));   
  if (strstr (imagem[nvi-1], ".p"))
    ply=1;
  else if (strstr(imagem[nvi-1],".rif"))
    rif=1;
  else if (strstr(imagem[nvi-1],".txt"))
    txt=1;
  
  if (!ply && !rif && !txt){
    printf("\n ERRO... Digite o nome da imagem no formato ply, rif ou txt ");
    printf("\n > regvartxt <.ply> | <.rif> | <.txt> \n");
  }
}
void getimageint(){
  nome_image();
  le_e_escreve_arquivos();
  registro();
}

void le_e_escreve_arquivos(){
  le_imagem();
  cria_malhas_densas_smfeply();
  simplifica_malha_densa_smf();
  gera_mapa_curvatura();
}
  
void registro(){
  init_pairs();
 casamento_triedros();
}

void associa_normal_amostra(void){

  int i,ii,j,i0,i2,j0,j2,cont;
  Point2 pgon[3], point;
  Img_cart *f, *g[8];
  double a,b,c;
  Point3 vert[3];
  Indice ind;

  for ( cont=i = 0; i < nvertfacessimp[nvi-1].j; i++ ) {
    for (i0 = X_MAX[nvi-1]+1, j0 = Y_MAX[nvi-1]+1,i2=j2 = -1, j=0; j<3; j++) {
      if (vertices[nvi-1][faces[nvi-1][i].ind[j]].indI.i!=-1){
        memcpy (&(vert[j]),&(vertices[nvi-1][faces[nvi-1][i].ind[j]].X),sizeof(Point3)); 
        memcpy (&ind,&(vertices[nvi-1][faces[nvi-1][i].ind[j]].indI),sizeof(Indice));
        pgon[j].x=vert[j].x; pgon[j].y=vert[j].y;
        if (i0 > ind.i) i0 = ind.i;   if (i2 < ind.i) i2 = ind.i;
        if (j0 > ind.j) j0 = ind.j;   if (j2 < ind.j) j2 = ind.j;
      } 
    }
    
    if (faces[nvi-1][i].N.z>=0)
      for (ii = i0; ii<=i2; ii++ ) {
        for ( j = j0; j<=j2; j++ ) {
          f = array_orig[nvi-1][ii][j];
          if ( f ){
            point.x=f->X.x; point.y=f->X.y;
            coord_baryc(&(pgon[0]),&(pgon[1]),&(pgon[2]),&point, &a, &b, &c);
            if (a>=0 && a<=1 && b>=0 && b<=1 && c>=0 && c<=1){
              if (!f->misto){
                memcpy (&(f->normal),&(faces[nvi-1][i].N),sizeof(Point3));
                memcpy(&(f->pto_ext),&(vert[0]),sizeof(Point3));
                f->misto=1;
                cont++;
              }
            }
          }
        }
      }
  }
    /* Apoiada na continuidade .... */
    
  for ( ii = 0; ii<=X_MAX[nvi-1]; ii++ ) {
    for ( j = 0; j<=Y_MAX[nvi-1]; j++ ) {
      f = array_orig[nvi-1][ii][j];
      if ( f && !f->normal.x && !f->normal.y && !f->normal.z){
        g[0] = array_orig[nvi-1][ii-1][j-1]; g[1] = array_orig[nvi-1][ii-1][j];
          g[2] = array_orig[nvi-1][ii-1][j+1]; g[3] = array_orig[nvi-1][ii][j+1];
          g[4] = array_orig[nvi-1][ii+1][j+1]; g[5] = array_orig[nvi-1][ii+1][j];
          g[6] = array_orig[nvi-1][ii+1][j-1]; g[7] = array_orig[nvi-1][ii][j-1];
          for (i=0;i<8;i++){
            if (g[i] && g[i]->normal.x && g[i]->normal.y && g[i]->normal.z){
              memcpy (&(f->normal),&(g[i]->normal),sizeof(Point3));
              memcpy(&(f->pto_ext),&(g[i]->pto_ext),sizeof(Point3));
              memcpy(&(f->id_face),&(g[i]->id_face),sizeof(int));
              //f->misto=1;
              cont++;
            }
          }
        }
    }
  }
  for ( ii = 0; ii<=X_MAX[nvi-1]; ii++ ) {
    for ( j = 0; j<=Y_MAX[nvi-1]; j++ ) {
      f = array_orig[nvi-1][ii][j];
      if ( f && !f->normal.x && !f->normal.y && !f->normal.z){
          g[0] = array_orig[nvi-1][ii-1][j-1]; g[1] = array_orig[nvi-1][ii-1][j];
          g[2] = array_orig[nvi-1][ii-1][j+1]; g[3] = array_orig[nvi-1][ii][j+1];
          g[4] = array_orig[nvi-1][ii+1][j+1]; g[5] = array_orig[nvi-1][ii+1][j];
          g[6] = array_orig[nvi-1][ii+1][j-1]; g[7] = array_orig[nvi-1][ii][j-1];
          for (i=0;i<8;i++){
            if (g[i] && g[i]->normal.x && g[i]->normal.y && g[i]->normal.z){
              memcpy (&(f->normal),&(g[i]->normal),sizeof(Point3));
              memcpy(&(f->pto_ext),&(g[i]->pto_ext),sizeof(Point3));
              memcpy(&(f->id_face),&(g[i]->id_face),sizeof(int));
              //f->misto=1;
              cont++;
            }
          }
          if  (!f->normal.x && !f->normal.y && !f->normal.z){
            printf ("\n NADA");
            f->misto=2;
          }
      }
    }
  }
   for ( i=0; i<=X_MAX[nvi-1]; i++ ) {
      for ( j = 0; j<=Y_MAX[nvi-1]; j++ ) {
        f = array_orig[nvi-1][i][j];
        if ( f && f->misto )
          f->misto=0;
      }
  }
  
  printf ("\n No amostras que estao dentro de alguma face :%d",cont);
  
}

void casamento_triedros(void){
  
  int n_triedros_com_semelhante_curvatura=0;
  int RAIO1=40,RAIO2=50,a,b,c,d,e,f,im,iM,jm,jM,indic, indicdet,in2;
  int i3m,i3M,j3m,j3M,flag,i2m, i2M, j2m, j2M,indic0,indic1,indic2;
  int i6m,i6M,j6m,j6M,i7m,i7M,j7m,j7M;
  int porc, porcant,l,indice,i,j, k, candidatos_p=0,n_triedros=0,ncorr,ncorr0;
  int alig, idet, jdet=0,cont1,quar, zant, qtyf,z,triedros_com;
  double Tolcurv, z1,z1det, desv1[4],cosanglemin; 
  double cosangle,cosangle2,f1,f2;
  double dist01,dist02,dist03,dist12,dist13, dist23, raio01,raio02,raio03;
  double Dp,max,maxcomsinal,r1,r2,difcurvmin,Toldist;
  double dista01,dista02,dista03,dista12,dista13,dista23,dista;
  double distaq,t0,t02,dista2,raio12,a1,b1,c1;
  Indice ind;
  extern double A;
  
  Point3 V3[4],V4[4],tra,tradef,proj,v2proj,v10,point;
  Vector3 N[3],Naux,Naux2,Naux3,Naux4;
  

  Faces *TodasFaces;
  Quaternion rot, rotdef;
  Matrix4  T,Rdef;
  struct timeval t1,t2,temps;
  extern Matrix4 R0;
  int aflag[670][670], aflag2[670][670];
  
  Candidatos *cand; FILE  *arq;

 gettimeofday(&t1,NULL); 
  /* Atencao */

 if ( (arq = fopen("triedros","w")) == NULL ) {
   printf("\n Arquivo 'ran' nao foi aberto!! \n\n");
   exit(1); 
 }

 Toldist=4.0*maxInts[0]*A/140.0;

 Tolreg=Toldist;
 // Tolreg=4.0*maxInts[0];
  
 /* 9000 media de amostras de imagens MINOLTA */
 // Tolreg=Tolreg/2;
 Tolcurv=maxInts[0]*A/700;
 
 /* Definindo RAIOS em funcao do tamanho da imagem */
 raio12=(2*(raiomenor[nvi-2]+raiomeio[nvi-2]+raio[nvi-2])/3)/maxInts[0];

 f1=0.01;
 f2=0.3;
 RAIO1=(int)(raio12*f1);
 RAIO2=(int)(raio12*f2);
 
 printf ("\n RAIO1 : %d | RAIO2 : %d",RAIO1, RAIO2);
 
 r1=RAIO1*maxInts[0];
 r2=RAIO2*maxInts[0]; 
    
  for (i=0; i<X_MAX[nvi-2]; i++) {
    for (k=0; k<Y_MAX[nvi-2]; k++){
      aflag[i][k] = 0;  
    }
  }

  for (i=0; i<X_MAX[nvi-1]; i++) {
    for (k=0; k<Y_MAX[nvi-1]; k++){
      aflag2[i][k]=0;
    }
  }
  
  cand= (Candidatos *) malloc(sizeof (Candidatos)*(nvertfacessimp[nvi-2].i+1));
  memcpy (&(Rdef),&(R[0]),sizeof(Matrix4));
  gettimeofday(&t1,NULL); 

  associa_normal_amostra();
  
  TodasFaces = (Faces *) malloc(sizeof (Faces)*(nvertfacessimp[nvi-2].j+1));
  
  for (qtyf=j=0; j<nvertfacessimp[nvi-2].j; j++) {
    if (!faces[nvi-2][j].borda){
      TodasFaces[qtyf].id_face=j;
      memcpy (&(TodasFaces[qtyf].B),&(faces[nvi-2][j].B),sizeof(Point3));
      memcpy (&(TodasFaces[qtyf++].N),&(faces[nvi-2][j].N),sizeof(Point3));
    } 
  }
  
  for (k=j=0; j<nvertfacessimp[nvi-2].i; j++) {
    if (vertices[nvi-2][j].indI.i!=-1){
      aflag[vertices[nvi-2][j].indI.i][vertices[nvi-2][j].indI.j]=j+1;
      k++;
    }
  }
  if (k<nvertfacessimp[nvi-2].i)
    printf ("\n Alguns vertices nao tem amostras proximas");
  
  for (k=j=0; j<nvertfacessimp[nvi-1].i; j++) {
    if (vertices[nvi-1][j].indI.i!=-1){
      aflag2[vertices[nvi-1][j].indI.i][vertices[nvi-1][j].indI.j]=j+1;
      k++;
    }
  }
  if (k<nvertfacessimp[nvi-1].i)
    printf ("\n Alguns vertices nao tem amostras proximas");
  
  /* Procurando as vizinhancas com curvatura aprox. igual*/
   for (n_triedros=triedros_com=j=0; j<nvertfacessimp[nvi-2].i; j++) {
     quar=0;
     cand[j].nro=0;
     if (!vertices[nvi-2][j].borda){
       n_triedros++;
       for (k=0;k<nvertfacessimp[nvi-1].i;k++){
         difcurvmin=fabs((vertices[nvi-2][j].curvmin+vertices[nvi-2][j].curvmax)/2-(vertices[nvi-1][k].curvmin+vertices[nvi-1][k].curvmax)/2);
         if (difcurvmin<Tolcurv){
           vertices[nvi-1][k].item=1;
           cand[j].corresp[quar++]=k;
         }
       }
     }
     cand[j].nro=quar;
     if (quar)
       triedros_com++;
   }
   fprintf(arq,"%d \n",triedros_com);
   printf("\n [ErrosSimplificacao: Im1 : %2.3f | Im2 : %2.3f]",
         erros[0],erros[1]);
   printf ("\n No de Triedros: %d",n_triedros);
   /* Fazendo o casamento de um triedro */
   if (f1<0.25)
     porcant=(int)(f1*qtyf);
   else
     porcant=(int)(0.25*qtyf);
   printf("\n [Npontos1=%d | Nvert1=%d | Nvnaoborda1=%d |PSimplNaoborda=%1.3f | PSimpl = %1.3f]", NUM_PTOS[0], nvertfacessimp[nvi-2].i, n_triedros, ((double)(n_triedros)/(double)(NUM_PTOS[0]))*100, (double)(nvertfacessimp[nvi-2].i)/(double)(NUM_PTOS[0]));
   for (i=cont1=0,j=0; j<nvertfacessimp[nvi-2].i; j++) {
     if (cand[j].nro){
       
       n_triedros_com_semelhante_curvatura++;
       printf ("\n Ha %d candidatos de %d vertices da malha D",cand[j].nro,nvertfacessimp[nvi-1].i);
       
       memcpy (&(R0),&(R[0]),sizeof(Matrix4));
       nro_ve[0]=j;
       im=vertices[nvi-2][j].indI.i-RAIO2; iM=vertices[nvi-2][j].indI.i+RAIO2;
       jm=vertices[nvi-2][j].indI.j-RAIO2; jM=vertices[nvi-2][j].indI.j+RAIO2;
       if (im<0) im=0; if (iM>=X_MAX[nvi-2]) iM=X_MAX[nvi-2]-1;
       if (jm<0) jm=0; if (jM>=Y_MAX[nvi-2]) jM=Y_MAX[nvi-2]-1;
       
       memcpy (&(V3[0]),&(vertices[nvi-2][j].X),sizeof(Point3));
       
       indice=0;
       for (a=im;a<=iM ;a++){
         for (b=jm;b<=jM ;b++){
           if (aflag[a][b]){
             in2=aflag[a][b]-1;
             dista=V3DistanceBetween2Points(&(V3[0]),&(vertices[nvi-2][in2].X));
             if (dista>=r1 && dista<=r2 ){
               memcpy(&(V3[1]),&(vertices[nvi-2][in2].X),sizeof(Point3));
			vertices[nvi-2][j].indi[0]=in2;
			V3Sub(&(V3[1]),&(V3[0]),&(N[0]));
                        V3Normalize(&(N[0]));
                        for (cosanglemin=MAXFLOAT,c=im;c<=iM;c++){
                for (d=jm;d<=jM;d++){
                  if (aflag[c][d]){
                    in2=aflag[c][d]-1;
                    dista=V3DistanceBetween2Points(&(V3[0]),&(vertices[nvi-2][in2]).X);
                    V3Sub(&(vertices[nvi-2][in2].X),&(V3[0]),&(N[1]));
                    V3Normalize(&(N[1]));
                    cosangle=V3Dot(&(N[0]),&(N[1]));
                    if (cosangle>1)
                      cosangle=cosangle-0.00001;
                    else if (cosangle<-1)
                      cosangle=cosangle+0.00001;
                    if (dista>=r1 && dista<=r2 &&
                        fabs(cosangle)<cosanglemin){
                      memcpy(&(V3[2]),&(vertices[nvi-2][in2].X),sizeof(Point3));
                      indice=1;       
                      cosanglemin=fabs(cosangle);
                      cosangle2=cosangle;
                      vertices[nvi-2][j].indi[1]=in2;
                      memcpy (&Naux,&(N[0]),sizeof(Point3));
                      memcpy (&Naux2,&(N[1]),sizeof(Point3));
                    }
                  }
                } 
              }
              if (indice){
                
                indice=0;
                memcpy (&(N[0]),&Naux, sizeof(Point3));
                memcpy (&(N[1]),&Naux2,sizeof(Point3));
                V3Cross(&(N[0]),&(N[1]),&Naux3);
                V3Normalize(&Naux3);
                
                for (max=-MAXFLOAT,e=im;e<=iM;e++){
                  for (f=jm;f<=jM;f++){
                    if (aflag[e][f]){
                      in2=aflag[e][f]-1;
                      dista=V3DistanceBetween2Points(&(V3[0]),&(vertices[nvi-2][in2].X));
                      V3Sub(&(vertices[nvi-2][in2].X), &(V3[0]), &Naux4);
                      Dp=V3Dot(&Naux4,&Naux3);
                      if (dista>=r1 && dista<=r2 && fabs(Dp)>max
                          && in2!=vertices[nvi-2][j].indi[0] &&
                          in2!=vertices[nvi-2][j].indi[1]){
                        
                        memcpy(&(V3[3]),&(vertices[nvi-2][in2].X),sizeof(Point3));
                        max=fabs(Dp);
                        maxcomsinal=Dp;
                        vertices[nvi-2][j].indi[2]=in2;
                        indice=1;
                      }
                    }
                  }
                }
              }
              a=iM;b=jM;
            }
          }
        }
      }
      if (!indice)
        vertices[nvi-2][j].indi[0]=-1;
      
      if (indice){
        fprintf(arq,"%d %d %d %d\n",j, vertices[nvi-2][j].indi[0],
                vertices[nvi-2][j].indi[1], vertices[nvi-2][j].indi[2]);
        
        point.x=V3[3].x-maxcomsinal*Naux3.x;
        point.y=V3[3].y-maxcomsinal*Naux3.y;
        point.z=V3[3].z-maxcomsinal*Naux3.z;
        
        coord_barycentric3(&(V3[0]), &(V3[1]), &(V3[2]), &(point),
                           &a1, &b1, &c1);
        //   InitDisplay(); DrawDisplay();
        dist01=V3DistanceBetween2Points(&(V3[0]),&(V3[1]));
        dist02=V3DistanceBetween2Points(&(V3[0]),&(V3[2]));
        dist03=V3DistanceBetween2Points(&(V3[0]),&(V3[3]));
	dist12=V3DistanceBetween2Points(&(V3[1]),&(V3[2]));
	dist13=V3DistanceBetween2Points(&(V3[1]),&(V3[3]));
	dist23=V3DistanceBetween2Points(&(V3[2]),&(V3[3]));
        raio01=(int)(ROUND(dist01/maxInts[0]))+5;
        raio02=(int)(ROUND(dist02/maxInts[0]))+5;
        raio03=(int)(ROUND(dist03/maxInts[0]))+5;
        raio12=(int)(ROUND(dist12/maxInts[0]))+5;
        printf ("\n =========================================================");     
        printf ("\n Numero| Dist1 | Dist2 | Dist3 | Desv1 | Desv2 | Desv3 | Desv4");
        printf ("\n =========================================================");
        printf ("\n %4d | %2.3f| %2.3f | %2.3f | %2.3f | %2.3f | %2.3f | %2.3f |",n_triedros_com_semelhante_curvatura,dist01,dist02,dist03,vertices[nvi-2][j].curvmin,vertices[nvi-2][vertices[nvi-2][j].indi[0]].curvmin, vertices[nvi-2][vertices[nvi-2][j].indi[1]].curvmin, vertices[nvi-2][vertices[nvi-2][j].indi[2]].curvmin);
        
        printf ("\n --------------------------------------------------------");
        printf ("\n Alinh| Dife1 |  Dife2 |  Dife3 |DiDesv1|DiDesv2|DiDesv3|DiDesv4|");
        printf ("\n --------------------------------------------------------");

        /* Calcula o parametro t0 (correspondente a projecao de 2 sobre 01
           e distaq = a distancia entre projecao de 2 sobre 01 e o vertice 2*/
        DstPntLine(V3[2],V3[0],V3[1],&distaq,&t0);
       
        /* Procura na malha 2 */
        for (flag=0,k=0;k<cand[j].nro;k++){
          indic=cand[j].corresp[k];
          im=vertices[nvi-1][indic].indI.i-raio01;
          iM=vertices[nvi-1][indic].indI.i+raio01;
          jm=vertices[nvi-1][indic].indI.j-raio01;
          jM=vertices[nvi-1][indic].indI.j+raio01;
          
          memcpy (&(V4[0]),&(vertices[nvi-1][indic].X),sizeof(Point3));
          
          if (im<0) im=0; if (iM>=X_MAX[nvi-1]) iM=X_MAX[nvi-1]-1;
          if (jm<0) jm=0; if (jM>=Y_MAX[nvi-1]) jM=Y_MAX[nvi-1]-1;
                
          i2m=vertices[nvi-1][indic].indI.i-raio02;
          i2M=vertices[nvi-1][indic].indI.i+raio02;
          j2m=vertices[nvi-1][indic].indI.j-raio02;
          j2M=vertices[nvi-1][indic].indI.j+raio02;
          if (i2m<0) i2m=0; if (i2M>=X_MAX[nvi-1]) i2M=X_MAX[nvi-1]-1;
          if (j2m<0) j2m=0; if (j2M>=Y_MAX[nvi-1]) j2M=Y_MAX[nvi-1]-1;

                   i3m=vertices[nvi-1][indic].indI.i-raio03;
          i3M=vertices[nvi-1][indic].indI.i+raio03;
          j3m=vertices[nvi-1][indic].indI.j-raio03;
          j3M=vertices[nvi-1][indic].indI.j+raio03;
          if (i3m<0) i3m=0; if (i3M>=X_MAX[nvi-1]) i3M=X_MAX[nvi-1]-1;
          if (j3m<0) j3m=0; if (j3M>=Y_MAX[nvi-1]) j3M=Y_MAX[nvi-1]-1;
          
          nro_ve[1]=indic;
          vertices[nvi-1][indic].indi[0]=-1; 
          for (a=im;a<=iM ;a++){
            for (b=jm;b<=jM ;b++){
              if (aflag2[a][b]){
                in2=aflag2[a][b]-1;
                memcpy(&(V4[1]),&(vertices[nvi-1][in2].X),sizeof(Point3));
                dista01=V3DistanceBetween2Points(&(V4[0]),&(V4[1]));
                if (fabs(dista01-dist01)<=Toldist){
                  difcurvmin=fabs((vertices[nvi-2][vertices[nvi-2][j].indi[0]].curvmin+vertices[nvi-2][vertices[nvi-2][j].indi[0]].curvmax)/2-(vertices[nvi-1][in2].curvmin+vertices[nvi-1][in2].curvmax)/2);
                  if (difcurvmin<Tolcurv){
                    vertices[nvi-1][indic].indi[0]=in2;
                    i6m=a-raio12; i6M=a+raio12; j6m=b-raio12; j6M=b+raio12;
                    
                    if (i6m<0) i6m=0; if (i6M>X_MAX[nvi-1]) i6M=X_MAX[nvi-1];
                    if (j6m<0) j6m=0; if (j6M>Y_MAX[nvi-1]) j6M=Y_MAX[nvi-1];
                    
                    /* Intersecao das duas regioes quadradas */
                    
                    if (i2m>i6m) i6m=i2m; if (j2m>j6m) j6m=j2m;
                    if (i2M<i6M) i6M=i2M; if (j2M<j6M) j6M=j2M;
                    
                    v10.x = V4[1].x-V4[0].x;
                    v10.y = V4[1].y-V4[0].y;
                    v10.z = V4[1].z-V4[0].z;
                    
                    proj.x = V4[0].x + (t0) * (v10.x);
                    proj.y = V4[0].y + (t0) * (v10.y);
                    proj.z = V4[0].z + (t0) * (v10.z);
                    
                    for (c=i6m;c<=i6M;c++){
                        for (d=j6m;d<=j6M;d++){
                          if (aflag2[c][d] && (aflag2[c][d]-1)!=indic){
                            in2=aflag2[c][d]-1;
                            memcpy(&(V4[2]),&(vertices[nvi-1][in2].X),sizeof(Point3));
                            dista02=V3DistanceBetween2Points(&(V4[0]),&(V4[2])); 
			    dista12=V3DistanceBetween2Points(&(V4[1]),&(V4[2]));
                            v2proj.x=V4[2].x-proj.x;
                            v2proj.y=V4[2].y-proj.y;
                            v2proj.z=V4[2].z-proj.z;
                            dista2=V3Dot(&(v2proj),&(v2proj));
                            /*perpendicularidad*/
                            t02=V3Dot(&(v10),&(v2proj))/dista2;
                            dista2=sqrt(dista2);
                            if (fabs(distaq-dista2)<=Toldist && fabs(dista02-dist02)<=Toldist && fabs(dista12-dist12)<=Toldist/* && fabs(t02)<0.1*/ ){
                              difcurvmin=fabs((vertices[nvi-2][vertices[nvi-2][j].indi[1]].curvmin+vertices[nvi-2][vertices[nvi-2][j].indi[1]].curvmax)/2-(vertices[nvi-1][in2].curvmin+vertices[nvi-1][in2].curvmax)/2);
			      if (difcurvmin<Tolcurv){
                                vertices[nvi-1][indic].indi[1]=in2;
                                V3Sub(&(V4[1]),&(V4[0]),&(N[0]));  
                                V3Sub(&(V4[2]),&(V4[0]),&(N[1]));
                                V3Cross(&(N[0]),&(N[1]),&Naux3);
                                V3Normalize(&Naux3);
                                
                                point.x=a1*V4[0].x+b1*V4[1].x+c1*V4[2].x;
                                point.y=a1*V4[0].y+b1*V4[1].y+c1*V4[2].y;
                                point.z=a1*V4[0].z+b1*V4[1].z+c1*V4[2].z;
                                point.x=point.x+maxcomsinal*Naux3.x;
                                point.y=point.y+maxcomsinal*Naux3.y;
                                point.z=point.z+maxcomsinal*Naux3.z;
                          
                                indice_para_ponto_dist_registro3(point,&ind);

                                if (ind.i!=-1){ 
                                  i7m=ind.i-5; i7M=ind.i+5;
                                  j7m=ind.j-5; j7M=ind.j+5;
                                  
                                  if (i7m<0) i7m=0;
                                  if (i7M>X_MAX[nvi-1]) i7M=X_MAX[nvi-1];
                                  if (j7m<0) j7m=0;
                                  if (j7M>Y_MAX[nvi-1]) j7M=Y_MAX[nvi-1];
                                  
                                  if (i3m>i7m) i7m=i3m; if (j3m>j7m) j7m=j3m;
                                  if (i3M<i7M) i7M=i3M; if (j3M<j7M) j7M=j3M;
                                  
                                  for (e=i7m;e<=i7M;e++){
                                    for (f=j7m;f<=j7M;f++){
                                      if (aflag2[e][f]){
                                        in2=aflag2[e][f]-1;
                                        memcpy(&(V4[3]),&(vertices[nvi-1][in2].X),sizeof(Point3));
                                        dista03=V3DistanceBetween2Points(&(V4[0]),&(V4[3]));
					dista13=V3DistanceBetween2Points(&(V4[1]),&(V4[3]));
					dista23=V3DistanceBetween2Points(&(V4[2]),&(V4[3]));
                                        V3Sub(&(V4[3]), &(V4[0]), &(N[2]));
                                        Dp=V3Dot(&(N[2]),&Naux3);
                                        
                                        V3Normalize(&(N[2]));
                                        if (fabs(dista03-dist03)<=Toldist && 
					    fabs(dista23-dist23)<=Toldist &&
					    fabs(dista13-dist13)<=Toldist &&
                                            fabs(Dp-maxcomsinal)<=Toldist ){
                                          difcurvmin=fabs((vertices[nvi-2][vertices[nvi-2][j].indi[2]].curvmin+vertices[nvi-2][vertices[nvi-2][j].indi[2]].curvmax)/2-(vertices[nvi-1][in2].curvmin+vertices[nvi-1][in2].curvmax)/2);
                                          if (difcurvmin<Tolcurv){  
                                              flag=1;
                                              vertices[nvi-1][indic].indi[2]=in2;
                                              init_pairs();
                                              for (l=0;l<4;l++)
                                                add_pair(V3[l],V4[l]);
                                              
                                              match_pairs (&T, l, &rot, &tra); alig=0;
                                              cont1++;
                                              ncorr=0;
                                              if (check_alig2(T, TodasFaces, qtyf, &porc, porcant, &ncorr)){
                                                /*if (check_alig_malha2(T,TodasFaces,qtyf,TodasFaces2, qtyf2,&porc,porcant,&ncorr)){*/
                                                if (porcant<porc ){
                                                  candidatos_p++;
                                                  porcant=porc;
                                                  ncorr0=ncorr;
                                                  update_mesh(T);
                                                  memcpy (&R0,&(T),sizeof(Matrix4));
                                                  printf ("\n %4d | %2.3f| %2.3f | %2.3f | %2.3f | %2.3f | %2.3f | %2.3f |",porcant,fabs(dist01-dista01),fabs(dista02-dist02),fabs(dist03-dista03),fabs(vertices[nvi-1][indic].curvmin-vertices[nvi-2][j].curvmin), fabs(vertices[nvi-1][vertices[nvi-1][indic].indi[0]].curvmin-vertices[nvi-2][vertices[nvi-2][j].indi[0]].curvmin), fabs(vertices[nvi-1][vertices[nvi-1][indic].indi[1]].curvmin-vertices[nvi-2][vertices[nvi-2][j].indi[1]].curvmin), fabs(vertices[nvi-1][vertices[nvi-1][indic].indi[2]].curvmin-vertices[nvi-2][vertices[nvi-2][j].indi[2]].curvmin)); 
                                                  //InitDisplay(); DrawDisplay();
                                                  retrieve_mesh();
                                                  memcpy (&(Rdef),&(T),sizeof(Matrix4));
                                                  memcpy (&(rotdef),&rot,sizeof(Quaternion));
                                                  memcpy(&tradef,&tra, sizeof(Point3));
                                                  jdet=j;
                                                  idet=n_triedros_com_semelhante_curvatura;
                                                  indicdet=indic;
                                                  indic0=vertices[nvi-1][indic].indi[0];
                                                  indic1=vertices[nvi-1][indic].indi[1];
                                                  indic2=vertices[nvi-1][indic].indi[2];
                                                  z1det=z1;
                                                  desv1[0]=fabs((vertices[nvi-2][j].curvmin+vertices[nvi-2][j].curvmax)/2-(vertices[nvi-1][indic].curvmin+vertices[nvi-1][indic].curvmax)/2);
						  for (z=0;z<3;z++){
						      desv1[z+1]=fabs((vertices[nvi-2][vertices[nvi-2][j].indi[z]].curvmin+vertices[nvi-2][vertices[nvi-2][j].indi[z]].curvmax)/2-(vertices[nvi-1][vertices[nvi-1][indic].indi[z]].curvmin+vertices[nvi-1][vertices[nvi-1][indic].indi[z]].curvmax)/2);
                                                  }
                                                }
                                              }
                                          }
                                        }
                                      }
                                    }
                                }
                              }
                              }
                            }
                          }
                        }
                      }
                    }
                }
              }
            }
          }
        }
      }
      }
  }
  fclose(arq);
  gettimeofday(&t2,NULL);
  temps.tv_sec=t2.tv_sec-t1.tv_sec; 
  temps.tv_usec=t2.tv_usec-t1.tv_usec;
  printf ("\n Tempo passado = %d segs e %d usgs \n", temps.tv_sec, temps.tv_usec);
   printf ("\n Tempo passado x iteracao= %1.2f segs\n", (double)temps.tv_sec/n_triedros);
  
  if (cont1){
    nro_ve[0]=jdet;
    nro_ve[1]=indicdet;
    vertices[nvi-1][indicdet].indi[0]=indic0;
    vertices[nvi-1][indicdet].indi[1]=indic1;
    vertices[nvi-1][indicdet].indi[2]=indic2;

    memcpy (&(R0),&(Rdef),sizeof(Matrix4));
    update_mesh(Rdef);
    printf("\n [ErrosSimplificacao: Im1 : %2.3f | Im2 : %2.3f]",
           erros[0],erros[1]);

    printf("\n [ Toldist: %2.3f]" , Toldist);
    dista=V3DistanceBetween2Points(&(vertices[nvi-1][indicdet].X),
                                   &(vertices[nvi-2][jdet].X));
    printf ("\n [Dist.vertices 0 : %1.4f]",dista);
    for (i=1;i<4;i++){
      dista=V3DistanceBetween2Points(&(vertices[nvi-1][vertices[nvi-1][indicdet].indi[i-1]].X), &(vertices[nvi-2][vertices[nvi-2][jdet].indi[i-1]].X));
      printf ("\n [Dist.vertices %d : %1.4f]",i,dista);
    }
    
     printf("\n Matriz Transformacao");
    for (i=0;i<4;i++)
      for (j=0;j<4;j++)
          printf("\n R[0].element[%d][%d] = %2.6f ;",i,j,Rdef.element[i][j]);
    
    printf ("\n RAIO1 : %d | RAIO2 : %d",RAIO1,RAIO2);
    printf ("\n [Image1 :%s | Tamanho (%d x %d)]",imagem[0],X_MAX[nvi-2],Y_MAX[nvi-2]);
    printf ("\n [Image2 :%s | Tamanho (%d x %d)]",imagem[1],X_MAX[nvi-1],Y_MAX[nvi-1]);
    printf("\n [Espaco amostras Imag 1: [%2.3f,%2.3f] | Tolsimp: %2.3f | TolCurv: %2.3f | TolReg: %2.3f]",Int[nvi-2], Int2[nvi-2], Tolsimp,Tolcurv,Tolreg);
    printf("\n [Npontos1=%d | Nvert1=%d | Nvnaoborda1=%d |PSimplNaoborda=%1.3f | PSimpl = %1.3f]",
           NUM_PTOS[0], nvertfacessimp[nvi-2].i, n_triedros, ((double)(n_triedros)/(double)(NUM_PTOS[0]))*100, ((double)(nvertfacessimp[nvi-2].i)/(double)(NUM_PTOS[0]))*100);
    printf("\n [#Triedros1:%d| #Trie_com_sem:%d | Candidatos:%d | #Candidatos/Num_Ptos:%1.2f ]", n_triedros,n_triedros_com_semelhante_curvatura,cont1,((double)cont1/(double)(NUM_PTOS[1]))*100); 
printf("\n #TriedroReg :%d | TriedroReg #:%d]", idet,jdet);
 printf("\n [Dif Curvmedia.:%1.4f]",desv1[0]);
 for (i=1;i<4;i++)
     printf("\n [Dif Curvmedia.:%1.4f]",desv1[i]);
 
 printf("\n [NFaces1= %d |  NFacesnaoborda1=%d | Porc.Faces1 = %1.3f] ",nvertfacessimp[nvi-2].j, qtyf,(double)nvertfacessimp[nvi-2].j/(double)nfacesdensa[0]);
    printf("\n[Faces fte c/corresp:%d | Faces Alinhs:%d |Porc.Alinh.: %1.3f]",ncorr0,porcant, porcant/(double)ncorr0);
     printf("\n Namostras2 = %d | Nvertices2 = %d | PSimpl = %1.3f",
            NUM_PTOS[1], nvertfacessimp[nvi-1].i, ((double)(nvertfacessimp[nvi-1].i)/(double)(NUM_PTOS[1]))*100);
 printf("\n [Espaco amostras Imag 2: [%2.3f,%2.3f] ",Int[nvi-1], Int2[nvi-1]);
 
     printf("\n NFaces2= %d | Porc.Faces2 = %1.3f", nvertfacessimp[nvi-1].j,(double)nvertfacessimp[nvi-1].j/(double)nfacesdensa[1]);
       zant=0;ncorr0=0;
    ncorr0=zant=0;
    InitDisplay(); DrawDisplay();
  }
  free ((char *)cand);
  if (qtyf)
    free ((char *)TodasFaces);
}

int check_alig2(Matrix4 R, Faces *TodasFaces, int nro, int *porc, int porcant,
                int *ncorr){
  int i,cont, faces_fte_com_corresp=0,cont_faces_proximas=0;
  double dist;
  Indice I;
  Img_cart *f;
  Point3 normal11, baricentro,aux1;

  for (cont=i=0; i<nro;i++){
    cont++;
    memcpy (&(normal11),&(TodasFaces[i].N),sizeof(Point3));
    mesh_to_image(R,normal11,&normal11);
    normal11.x+=R.element[3][0];   normal11.y+=R.element[3][1];
    normal11.z+=R.element[3][2];
    V3Normalize(&normal11);
    
    if (normal11.z>=0.0){
      memcpy(&(baricentro),&(TodasFaces[i].B),sizeof(Point3));
      mesh_to_image(R,baricentro,&baricentro);
      indice_para_ponto_dist_registro(baricentro,&I);
      f=array_orig[nvi-1][I.i][I.j];
      if (I.i!=-1 ){
        //        f->misto=1;
        V3Sub(&(baricentro), &(f->pto_ext),&aux1);
         dist=V3Dot(&(aux1),&(f->normal));
         //dist=V3DistanceBetween2Points(&(baricentro),&(f->X));
        faces_fte_com_corresp++;
        if (fabs(dist)<=Tolreg)
            (cont_faces_proximas)++;
      }
    }
    if (RED1>=((double)((faces_fte_com_corresp) + nro-i-1)/(double)nro))
      return(0);
    if (porcant >=(cont_faces_proximas+nro-i-1))
      return(0);
  }
  (*porc)=cont_faces_proximas;
  (*ncorr)=faces_fte_com_corresp;
  return(1);
}

int mede_erro_amostras(Matrix4 R, int *alinh,int *ncorr){
  int i, j;
  Point3 aux;
  Indice I, array[670][670];
  double dist, aflag[670][670];
  Img_cart *f;

  for (i=0; i<X_MAX[nvi-2]; i++) 
    for (j=0; j<Y_MAX[nvi-2]; j++){
      aflag[i][j]=0.0;
      array[i][j].i=array[i][j].j=0;
    }
  
  for (i=0; i<X_MAX[nvi-2]; i++) {
    for (j=0; j<Y_MAX[nvi-2]; j++){
      if (array_orig[nvi-2][i][j] && !array_orig[nvi-2][i][j]->borda){
        memcpy(&(aux),&(array_orig[nvi-2][i][j]->X),sizeof(Point3));
        mesh_to_image(R, aux, &aux);
        /* Projeta sobre a imagem e tenta achar um ponto correspondente */
        indice_para_ponto_dist_registro(aux,&I);
        f=array_orig[nvi-1][I.i][I.j]; 
        if (I.i!=-1){
          mesh_to_image(R, array_orig[nvi-2][i][j]->X, &(array_orig[nvi-2][i][j]->X));
          V3Sub(&(aux), &(f->pto_ext), &aux);
          dist=V3Dot(&(aux),&(f->normal));
          array_orig[nvi-2][i][j]->misto=1; /* Frente visivel */
          if (!aflag[I.i][I.j]){
            (*ncorr)++;
            array[I.i][I.j].i=i; array[I.i][I.j].j=j;
            aflag[I.i][I.j]=dist;
            if (fabs(dist)<=Tolreg){
              (*alinh)++;
              array_orig[nvi-2][i][j]->misto=2;
            }
          }else
            if (fabs(dist-aflag[I.i][I.j])<4*maxInts[nvi-2]){
              (*ncorr)++;
              if (fabs(dist)<=Tolreg){
                (*alinh)++;
                array_orig[nvi-2][i][j]->misto=2;
              }
            }else{
              if (dist>aflag[I.i][I.j]){
                array_orig[nvi-2][array[I.i][I.j].i][array[I.i][I.j].j]->misto=3; /* Frente mas nao visivel */
                array[I.i][I.j].i=i; array[I.i][I.j].j=j;
                aflag[I.i][I.j]=dist;
              }else{
               array_orig[nvi-2][i][j]->misto=3;
              }
            }
        }
      }
    }
  }
  return (1);
}

