/*-----------------------------------------------------------------------
  Metodo do Registro de Duas Imagens.  2005 - DCA/FEEC/UNICAMP/SP/BR

   ENTRADA:
  (1) arquivo saida2 contendo os os tetraedros construidos pelos vertices
  da malha simplificada da imagem fonte mais os seus adjacentes
  O arquivo saida2 eh gerado pelo programa m_tetraedros.c
  (2) arquivo saida3 contendo a malha simplificada da imagem destino
  O arquivo saida3 eh gerado pelo executavel densa
  (3) imagem de profundidade da imagem destino 
  SAIDA: 
-------------------------------------------------------------------------*/
#include "estrut.h"
#include <stdio.h>
#include <math.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_eigen.h>
#include <gsl/gsl_sort.h>
#include <gsl/gsl_statistics.h>
#include <gsl/gsl_eigen.h>
#include <gsl/gsl_combination.h>

#define PI              3.14159265358979323846   /* the venerable pi */
#define RED1 0.2
/*Variaveis Globais 				        
--------------------------------------------------------------*/
extern double Int[2], Int2[2], erros[2], maxInts[2];
extern double Tolreg, Tolsimp;
Vertice **vertices;
Face **faces;
Indice *nvertfacessimp;
int array_flag[670][670];
extern int ply, rif, txt, nvi, *X_MAX, *Y_MAX, nfacesdensa[2];
extern double *raio,*raiomenor,*raiomeio;
int nro_ve[2], mediox,medioy,Obj;
extern char **imagem;
double cx_mod,cy_mod,cz_mod,xmin,xMax,ymin,yMax,zmin,zMax,Eps=FLT_EPSILON;
Matrix4 transf_mat, transf_mat_inv, transl_orig,transl_orig_inv,R0;
int FIMMDL=0, iteracao=0, NUM_PTOS[2];
Img_cart *array_orig[2][670][670];
extern Matrix4 R[3];
/***********************************************************************
	     Funcoes de outros modulos
***********************************************************************/
void mesh_to_image(Matrix4 ,Point3 ,Point3 *);
int coord_baryc(Point2 *,Point2 *,Point2 *,Point2 *,double *,double *,double *);int coord_barycentric3(Point3 *, Point3 *, Point3 *, Point3 *,double *,
                       double *, double *);
void init_pairs(void);
void add_pair(Point3, Point3 );
void indice_para_ponto_dist_registro (Point3 ,Indice *);
void indice_para_ponto_dist_registro3 (Point3 ,Indice *);
/************************************************************************
                    Funcoes do Modulo
*************************************************************************/
int check_alig2(Matrix4, Faces *, int, int *, int, int *);
void le_e_escreve_arquivos(void);
void cria_malhas_densas_smfeply(void);
void simplifica_malha_densa_smf(void);
void gera_mapa_curvatura(void);
void associa_normal_amostra(void);
void determina_normal_vertices (int);
void determina_array_flag(float );
int mede_erro_amostras(Matrix4, int *,int *);
int mede_erro_faces (Matrix4, Faces *, int , int *, int, int *, int *);
int check_alig_malha(Matrix4, Faces *, int ,double *, double, int *);
int check_alig_malha2(Matrix4, Faces *,int,int *,int,double *, double, int *);
int le_imagem(void);
void getimageint(void );
void nome_image(void);
void registro(void);
void match_pairs(Matrix4 *, int, Quaternion *, Point3 *);
void convert_quat_to_mat(Quaternion , Matrix4 *);
void casamento_triedros(void);
void update_mesh(Matrix4);
int check_align2(Matrix4, Point3 *, int, int *, int, int *);
void retrieve_mesh(void);
int mesmo_normal(int **, int **, Point3 **, Point3, Point3 *, int, int *,
                 int *,int *, int*);
void acha_normal(Point3 *, int, Point3 *);
void normaliza_arestas(Point3 *, Point3 , int);

void nome_image(){
  /* Le a imagem nvi-1 */
  rif=txt=ply=0; 
  
  imagem = (char**) realloc(imagem,sizeof(char*)*nvi);
  imagem[nvi-1] = (char*) malloc(30*sizeof(char));
  
  strcpy(imagem[nvi-1],"lobster-deg40.txt"); 
  //    strcpy(imagem[nvi-1],"happyStanRight96.txt");
  //       strcpy(imagem[nvi-1],"angel-deg60.txt");
  //  strcpy(imagem[nvi-1],"banana.oogl_scale150051.rif");
  strcpy(imagem[nvi-1],"pitbull.oogl_scale150025.rif");
  //strcpy(imagem[nvi-1],"frog0_03");
  // strcpy(imagem[nvi-1],"pitt.oogl_scale150018.rif");
  //  strcpy(imagem[nvi-1],"teletubby-deg300.txt");
  strcpy(imagem[nvi-1],"bird-deg60.txt");

 strcpy(imagem[nvi-1],"dino.oogl_scale150034.rif");

    strcpy(imagem[nvi-1],"machine.oogl_scale150005.rif");
    strcpy(imagem[nvi-1],"angel-deg40.txt");
    strcpy(imagem[nvi-1],"bluedino36.txt");
    strcpy(imagem[nvi-1],"hub.oogl_scale150009.rif");
    strcpy(imagem[nvi-1],"teletubby-deg60.txt");
    //       strcpy(imagem[nvi-1],"banana.oogl_scale150249.rif");
    strcpy(imagem[nvi-1],"happyStand48.txt");
    strcpy(imagem[nvi-1],"bunny90.txt");

    strcpy(imagem[nvi-1],"teletubby-deg240.txt");
//    strcpy(imagem[nvi-1],"pitt.oogl_scale150020.rif");

    strcpy(imagem[nvi-1],"pitbull.oogl_scale150025.rif");
     
  //scanf ("%s",&(imagem[nvi-1]));   
  if (strstr (imagem[nvi-1], ".ply"))
    ply=1;
  else if (strstr(imagem[nvi-1],".rif"))
    rif=1;
  else if (strstr(imagem[nvi-1],".txt"))
    txt=1;
  
  if (!ply && !rif && !txt){
    printf("\n ERRO... Digite o nome da imagem no formato ply, rif ou txt ");
    printf("\n > regvartxt <.ply> | <.rif> | <.txt> \n");
  }
}

void getimageint(){
  //  nome_image();
  //le_e_escreve_arquivos();
  // nvi--;
  casamento_triedros();
  //registro();
}

void le_e_escreve_arquivos(){
  le_imagem();
  cria_malhas_densas_smfeply();
  simplifica_malha_densa_smf();
  gera_mapa_curvatura();
}
  
void registro(){
  init_pairs();
 casamento_triedros();
}

void associa_normal_amostra(void){

  int i,ii,j,i0,i2,j0,j2,cont;
  Point2 pgon[3], point;
  Img_cart *f, *g[8];
  double a,b,c;
  Point3 vert[3];
  Indice ind;

  for ( cont=i = 0; i < nvertfacessimp[nvi-1].j; i++ ) {
    for (i0 = X_MAX[nvi-1]+1, j0 = Y_MAX[nvi-1]+1,i2=j2 = -1, j=0; j<3; j++) {
      if (vertices[nvi-1][faces[nvi-1][i].ind[j]].indI.i!=-1){
        memcpy (&(vert[j]),&(vertices[nvi-1][faces[nvi-1][i].ind[j]].X),sizeof(Point3)); 
        memcpy (&ind,&(vertices[nvi-1][faces[nvi-1][i].ind[j]].indI),sizeof(Indice));
        pgon[j].x=vert[j].x; pgon[j].y=vert[j].y;
        if (i0 > ind.i) i0 = ind.i;   if (i2 < ind.i) i2 = ind.i;
        if (j0 > ind.j) j0 = ind.j;   if (j2 < ind.j) j2 = ind.j;
      } 
    }
    
    if (faces[nvi-1][i].N.z>=0)
      for (ii = i0; ii<=i2; ii++ ) {
        for ( j = j0; j<=j2; j++ ) {
          f = array_orig[nvi-1][ii][j];
          if ( f ){
            point.x=f->X.x; point.y=f->X.y;
            coord_baryc(&(pgon[0]),&(pgon[1]),&(pgon[2]),&point, &a, &b, &c);
            if (a>=0 && a<=1 && b>=0 && b<=1 && c>=0 && c<=1){
              if (!f->misto){
                memcpy (&(f->normal),&(faces[nvi-1][i].N),sizeof(Point3));
                memcpy(&(f->pto_ext),&(vert[0]),sizeof(Point3));
                f->misto=1;
                cont++;
              }
            }
          }
        }
      }
  }
    /* Apoiada na continuidade .... */
    
  for ( ii = 0; ii<=X_MAX[nvi-1]; ii++ ) {
    for ( j = 0; j<=Y_MAX[nvi-1]; j++ ) {
      f = array_orig[nvi-1][ii][j];
      if ( f && !f->normal.x && !f->normal.y && !f->normal.z){
        g[0] = array_orig[nvi-1][ii-1][j-1]; g[1] = array_orig[nvi-1][ii-1][j];
          g[2] = array_orig[nvi-1][ii-1][j+1]; g[3] = array_orig[nvi-1][ii][j+1];
          g[4] = array_orig[nvi-1][ii+1][j+1]; g[5] = array_orig[nvi-1][ii+1][j];
          g[6] = array_orig[nvi-1][ii+1][j-1]; g[7] = array_orig[nvi-1][ii][j-1];
          for (i=0;i<8;i++){
            if (g[i] && g[i]->normal.x && g[i]->normal.y && g[i]->normal.z){
              memcpy (&(f->normal),&(g[i]->normal),sizeof(Point3));
              memcpy(&(f->pto_ext),&(g[i]->pto_ext),sizeof(Point3));
              memcpy(&(f->id_face),&(g[i]->id_face),sizeof(int));
              //f->misto=1;
              cont++;
            }
          }
        }
    }
  }
  for ( ii = 0; ii<=X_MAX[nvi-1]; ii++ ) {
    for ( j = 0; j<=Y_MAX[nvi-1]; j++ ) {
      f = array_orig[nvi-1][ii][j];
      if ( f && !f->normal.x && !f->normal.y && !f->normal.z){
          g[0] = array_orig[nvi-1][ii-1][j-1]; g[1] = array_orig[nvi-1][ii-1][j];
          g[2] = array_orig[nvi-1][ii-1][j+1]; g[3] = array_orig[nvi-1][ii][j+1];
          g[4] = array_orig[nvi-1][ii+1][j+1]; g[5] = array_orig[nvi-1][ii+1][j];
          g[6] = array_orig[nvi-1][ii+1][j-1]; g[7] = array_orig[nvi-1][ii][j-1];
          for (i=0;i<8;i++){
            if (g[i] && g[i]->normal.x && g[i]->normal.y && g[i]->normal.z){
              memcpy (&(f->normal),&(g[i]->normal),sizeof(Point3));
              memcpy(&(f->pto_ext),&(g[i]->pto_ext),sizeof(Point3));
              memcpy(&(f->id_face),&(g[i]->id_face),sizeof(int));
              //f->misto=1;
              cont++;
            }
          }
          if  (!f->normal.x && !f->normal.y && !f->normal.z){
            printf ("\n NADA");
            f->misto=2;
          }
      }
    }
  }
   for ( i=0; i<=X_MAX[nvi-1]; i++ ) {
      for ( j = 0; j<=Y_MAX[nvi-1]; j++ ) {
        f = array_orig[nvi-1][i][j];
        if ( f && f->misto )
          f->misto=0;
      }
  }
  
  printf ("\n No amostras que estao dentro de alguma face :%d",cont);
  
}

void casamento_triedros(void){
  
  int ntriedros;
  int porc, porcant,l,indice,i,j, k, candidatos_p=0,ncorr,ncorr0;
  int alig, idet, jdet=0,cont1,quar, zant, qtyf,z,triedros_com;
  double Tolcurv, z1,z1det, desv1[4],cosanglemin; 
  double cosangle,cosangle2;
  double dist01,dist02,dist03,dist12,dist13, dist23, raio01,raio02,raio03;
  double Dp,max,maxcomsinal,r1,r2,difcurvmin,Toldist;
  double dista01,dista02,dista03,dista12,dista13,dista23,dista;
  double distaq,t0,t02,dista2,raio12,a1,b1,c1;
  Indice ind;

  int elipti=0, hiperb=0, parabo=0, planar=0;
  double pelipti, phiperb, pparabo, pplanar;
  
  Point3 V3[4],V4[4],tra,tradef,proj,v2proj,v10,point;
  Faces *TodasFaces;
  Quaternion rot, rotdef;
  Matrix4  T,Rdef;
  struct timeval t1,t2,temps;
  extern Matrix4 R0;
  int aflag[670][670], aflag2[670][670];
  
 FILE  *arq;

 gettimeofday(&t1,NULL); 
  /* Atencao */

 if ( (arq = fopen("triedros","w")) == NULL ) {
   printf("\n Arquivo 'ran' nao foi aberto!! \n\n");
   exit(1);
 }

 Toldist=((double)(7)/((double)(NUM_PTOS[nvi-2])/9000))*Tolsimp;
 Tolreg=((double)(7)/((double)(NUM_PTOS[nvi-2])/9000))*Tolsimp;

 if (Toldist<(2.0*maxInts[0])){ 
   Toldist=2.0*maxInts[0];
   Tolreg=Toldist;
 }
 Toldist=3.0*maxInts[0];
 Tolreg=Toldist;

 /* 9000 media de amostras de imagens MINOLTA */
 // Tolreg=Tolreg/2;
  Tolcurv=maxInts[0]/7;
 
  for (i=0; i<X_MAX[nvi-2]; i++) {
    for (k=0; k<Y_MAX[nvi-2]; k++){
      aflag[i][k] = 0;  
    }
  }

  for (i=0; i<X_MAX[nvi-1]; i++) {
    for (k=0; k<Y_MAX[nvi-1]; k++){
      aflag2[i][k]=0;
    }
  }
  
  memcpy (&(Rdef),&(R[0]),sizeof(Matrix4));
  gettimeofday(&t1,NULL); 

  //  associa_normal_amostra();
  
  TodasFaces = (Faces *) malloc(sizeof (Faces)*nvertfacessimp[nvi-2].j);
  
  for (qtyf=j=0; j<nvertfacessimp[nvi-2].j; j++) {
    if (!faces[nvi-2][j].borda){
      TodasFaces[qtyf].id_face=j;
      memcpy (&(TodasFaces[qtyf].B),&(faces[nvi-2][j].B),sizeof(Point3));
      memcpy (&(TodasFaces[qtyf++].N),&(faces[nvi-2][j].N),sizeof(Point3));
    } 
  }
  
  for (k=j=0; j<nvertfacessimp[nvi-2].i; j++) {
    if (vertices[nvi-2][j].indI.i!=-1){
      aflag[vertices[nvi-2][j].indI.i][vertices[nvi-2][j].indI.j]=j+1;
      k++;
    }
  }
  if (k<nvertfacessimp[nvi-2].i)
    printf ("\n Alguns vertices nao tem amostras proximas");
  
  /* Classificacao de pontos */
  
   for (ntriedros=j=0; j<nvertfacessimp[nvi-2].i; j++) {
     if (!vertices[nvi-2][j].borda){
       ntriedros++;
       if ((fabs(vertices[nvi-2][j].curvmin)<0.005 &&
            fabs(vertices[nvi-2][j].curvmax)<0.005)){
         planar++;
         vertices[nvi-2][j].item=1;
       }
       else{
         if ((fabs(vertices[nvi-2][j].curvmin)<0.005 &&
              fabs(vertices[nvi-2][j].curvmax)>=0.005) ||
             (fabs(vertices[nvi-2][j].curvmin)>=0.005 &&
              fabs(vertices[nvi-2][j].curvmax)<0.005)){
           vertices[nvi-2][j].item=2;
           parabo++;
         } else if ((vertices[nvi-2][j].curvmin<-0.005 &&
                     vertices[nvi-2][j].curvmax<-0.005) ||
                    (vertices[nvi-2][j].curvmin>0.005 &&
                     vertices[nvi-2][j].curvmax>0.005)){
           elipti++;
            vertices[nvi-2][j].item=3;
         } else if ((vertices[nvi-2][j].curvmin<-0.005 &&
                     vertices[nvi-2][j].curvmax>0.005)||
                  (vertices[nvi-2][j].curvmin>0.005 &&
                   vertices[nvi-2][j].curvmax<-0.005)){
           hiperb++;
            vertices[nvi-2][j].item=4;
         }
         }
       }
   }
   pelipti=(double)(elipti)/(double)(ntriedros);
   phiperb=(double)(hiperb)/(double)(ntriedros);
   pplanar=(double)(planar)/(double)(ntriedros);
   pparabo=(double)(parabo)/(double)(ntriedros);

   printf("\n [ErrosSimplificacao: Im1 : %2.3f | Im2 : %2.3f]",
          erros[0],erros[1]);
   
   printf ("\n No de Vertices: %d | Vert.Nao borda: %d",
           nvertfacessimp[nvi-2].i, ntriedros);
   printf ("\n Elipt: %d | Hiperb: %d | Planares: %d| Parab: %d]",
           elipti,hiperb,planar,parabo);
   printf("\n [Nelipt=%1.3f | Nhiperb = %1.3f | Nplanar=%1.3f | Nparab=%1.3f ]", pelipti*100, phiperb*100, pplanar*100, pparabo*100);
   printf("\n [Nnaohiperbolicos=%1.3f | Nhiperb = %1.3f ]", (pelipti+pplanar+pparabo)*100, phiperb*100);

   if (qtyf)
     free ((char *)TodasFaces);
   nvi--;
}

int check_alig2(Matrix4 R, Faces *TodasFaces, int nro, int *porc, int porcant,
                int *ncorr){
  int i,cont, faces_fte_com_corresp=0,cont_faces_proximas=0;
  double dist;
  Indice I;
  Img_cart *f;
  Point3 normal11, baricentro,aux1;

  for (cont=i=0; i<nro;i++){
    cont++;
    memcpy (&(normal11),&(TodasFaces[i].N),sizeof(Point3));
    mesh_to_image(R,normal11,&normal11);
    normal11.x+=R.element[3][0];   normal11.y+=R.element[3][1];
    normal11.z+=R.element[3][2];
    V3Normalize(&normal11);
    
    if (normal11.z>=0.0){
      memcpy(&(baricentro),&(TodasFaces[i].B),sizeof(Point3));
      mesh_to_image(R,baricentro,&baricentro);
      indice_para_ponto_dist_registro(baricentro,&I);
      f=array_orig[nvi-1][I.i][I.j];
      if (I.i!=-1 ){
        //        f->misto=1;
        V3Sub(&(baricentro), &(f->pto_ext),&aux1);
         dist=V3Dot(&(aux1),&(f->normal));
         //dist=V3DistanceBetween2Points(&(baricentro),&(f->X));
        faces_fte_com_corresp++;
        if (fabs(dist)<=Tolreg)
            (cont_faces_proximas)++;
      }
    }
    if (RED1>=((double)((faces_fte_com_corresp) + nro-i-1)/(double)nro))
      return(0);
    if (porcant >=(cont_faces_proximas+nro-i-1))
      return(0);
  }
  (*porc)=cont_faces_proximas;
  (*ncorr)=faces_fte_com_corresp;
  return(1);
}

int mede_erro_amostras(Matrix4 R, int *alinh,int *ncorr){
  int i, j;
  Point3 aux;
  Indice I, array[670][670];
  double dist, aflag[670][670];
  Img_cart *f;

  for (i=0; i<X_MAX[nvi-2]; i++) 
    for (j=0; j<Y_MAX[nvi-2]; j++){
      aflag[i][j]=0.0;
      array[i][j].i=array[i][j].j=0;
    }
  
  for (i=0; i<X_MAX[nvi-2]; i++) {
    for (j=0; j<Y_MAX[nvi-2]; j++){
      if (array_orig[nvi-2][i][j] && !array_orig[nvi-2][i][j]->borda){
        memcpy(&(aux),&(array_orig[nvi-2][i][j]->X),sizeof(Point3));
        mesh_to_image(R, aux, &aux);
        /* Projeta sobre a imagem e tenta achar um ponto correspondente */
        indice_para_ponto_dist_registro(aux,&I);
        f=array_orig[nvi-1][I.i][I.j]; 
        if (I.i!=-1){
          mesh_to_image(R, array_orig[nvi-2][i][j]->X, &(array_orig[nvi-2][i][j]->X));
          V3Sub(&(aux), &(f->pto_ext), &aux);
          dist=V3Dot(&(aux),&(f->normal));
          array_orig[nvi-2][i][j]->misto=1; /* Frente visivel */
          if (!aflag[I.i][I.j]){
            (*ncorr)++;
            array[I.i][I.j].i=i; array[I.i][I.j].j=j;
            aflag[I.i][I.j]=dist;
            if (fabs(dist)<=Tolreg){
              (*alinh)++;
              array_orig[nvi-2][i][j]->misto=2;
            }
          }else
            if (fabs(dist-aflag[I.i][I.j])<4*maxInts[nvi-2]){
              (*ncorr)++;
              if (fabs(dist)<=Tolreg){
                (*alinh)++;
                array_orig[nvi-2][i][j]->misto=2;
              }
            }else{
              if (dist>aflag[I.i][I.j]){
                array_orig[nvi-2][array[I.i][I.j].i][array[I.i][I.j].j]->misto=3; /* Frente mas nao visivel */
                array[I.i][I.j].i=i; array[I.i][I.j].j=j;
                aflag[I.i][I.j]=dist;
              }else{
               array_orig[nvi-2][i][j]->misto=3;
              }
            }
        }
      }
    }
  }
  return (1);
}

