/*-----------------------------------------------------------------------
 Modulo: "funcaux " - Funcoes  auxiliares 
-----------------------------------------------------------------------*/
#ifdef SINGLE
#define REAL float
#else /* not SINGLE */ 
#define REAL double
#endif /* not SINGLE */

#include "estrut.h"
#include <gsl/gsl_sort.h>
#include <gsl/gsl_statistics.h>
#include <gsl/gsl_eigen.h>
#include <gsl/gsl_combination.h>
#define RED1 0.2

extern int ply, rif, txt, nfacesdensa[2];
extern char *curv[], *densa[], *simp[], **imagem;
extern Vertice **vertices;
extern Face **faces;
extern Indice *nvertfacessimp; 

extern int mediox,medioy,NUM_PTOS[2], *X_MAX, *Y_MAX, nvi, Obj, vert_nao_borda;
extern double Thresh,Eps, erros[2];
extern Img_cart *array_orig[2][670][670];
static Pair **pairs = NULL;
static int npairs = 0,max_pairs;
int auxi[670][670];
double Int[2],Int2[2],Tolreg=2.0,Tolsimp, IntMAX, maxInts[2];
/*---------------------------------------------------------------------     
             Funcoes do Modulo                                   
 ----------------------------------------------------------------------*/
void indice_para_ponto_dist_vertice (Point3 ,Indice *);
void indice_para_ponto_dist_registro (Point3 ,Indice *);
void indice_para_ponto_dist_registro3 (Point3 ,Indice *);
void indice_para_ponto_dist_registro4 (Point3 ,Indice *);
void indice_para_ponto_dist_registro1 (Point3 ,Indice *);
void indice_para_ponto_dist5 (Point3 , Indice *);
void indice_para_ponto_sem_repet (Point3 , Indice *);
void indice_para_ponto_misto (Point3 , Indice *, int);
void rotula_faces_vert_borda();
static IntPoint2 pesquisaBinaria(int , int , int, double *);  
void comprimento_aresta_malha (double *);
void cria_malhas_densas_smfeply (void );
void update_mesh(Matrix4);
void update_sample_data(Matrix4);
int le_imagem(void);
double face_height_xy(int, int *);
double altura_face(Point3, Point3, Point3);
double length_edge(int);
int DstPntLine(Point3 , Point3 , Point3 , double *, double *);
int coord_barycentric(double *, double *, double *, double *);
int area_triangulo(Point3, Point3, Point3, double *area);
int Vetcross_vert_face(int, Vector3 *);
int norface(int, Point3 *);
int dmax_dmin(double, double, double, double *, double *, double *);
int init_image_array(void);
int coord_barycentric3(Point3 *, Point3 *, Point3 *, Point3 *,double *,
                       double *, double *);
int coord_baryc(Point2 *, Point2 *, Point2 *, Point2 *,double *,
                       double *, double *);
int orienta_aresta(int, int *, int *);
int vizinhanca_de_frente (Point3 , Point3 *, int);
int area_triangulo2(Vertice **, double *);
int insere_list_ord(struct Listdist **,double,int);
int vert_is_concavo (Point3, Point3, Point3);
void normaliza_arestas(Point3 *, Point3, int);
void acha_normal(Point3 *, int , Point3 * );
double maior_erro_face (Point3, Point3 , Point3 );
double media_erro_face (Point3, Point3 , Point3, int * );
double mede_erro_malha (int *, int *, int );
void gera_mapa_curvatura(void);
void mesh_to_image(Matrix4,Point3 ,Point3 *);
/*********************************************************************/
int mede_erro_vertices(void){
  int k, cont=0, qtyv, *listv;
  Vertice *V;
  double erro, soma_erro=0.0;
  
  qtyv=0; listv=0;
  TdOAGetVertices(Obj, &qtyv, &listv); 
  for (k = 0; k<qtyv; k++ ) {
    TdVAGetDataPtr(listv[k], (void *)&V);
    if (V->indI.i!=-1){
      erro=V3DistanceBetween2Points(&(array_orig[nvi-1][V->indI.i][V->indI.j]->X),&(V->X));
      soma_erro+=erro;
      cont++;
    }
  }
  soma_erro/=cont;
  printf ("\n Nro Vertices : %d - O erro da malha eh :  %f ",qtyv, soma_erro);
  printf ("\n Nro amostras participantes do erro : %d ",cont);
  return(1);
}

int vert_is_concavo (Point3 ant, Point3 cor, Point3 prox){
 Point3 p0,p1;
 Vector3 V1,V2,n;
 
  p0.z = p1.z = 0.0;
  
  p0.x = cor.x; p0.y=cor.y;
  p1.x=ant.x; p1.y=ant.y;
  V3Sub(&p0,&p1,&V1);
  p1.x = prox.x; p1.y=prox.y;
  V3Sub(&p1,&p0,&V2); V3Cross(&V1,&V2,&n);
  /* Concavidade no vertice cor */
  if (n.z<0)
    return(1);
  else if (n.z<Eps)
    return(2);
  return(0);
}
/*---------------------------------------------------------------------*/
double length_edge(int edge)  {
  int i, qty, *list;
  Vertice *V[2];
  double length;
  
  qty=0; list=0;
  TdEAGetAdjVertices(edge, &qty,&list);
  if ( (qty - 2) ) { 
    printf("\n Erro!! Aresta com %d vertices(length_aresta) \n",qty);
  }
  for (i = 0; i<qty; i++) {
    TdVAGetDataPtr(list[i], (void *)&V[i]);
  }
  free((char *)list); 
  length = V3DistanceBetween2Points(&(V[0]->X), &(V[1]->X));
  return(length);
}
//*---------------------------------------------------------------------
/// 	Nome: DstPntLine  - Calcula distancia entre um ponto e a sua 
///                         projecao ortogonal sobre uma aresta.
///----------------------------------------------------------------*/
int DstPntLine(Point3 pto, Point3 P1, Point3 P2, double *dist, double *t){
  Vector3 dirseg, dircross;
  double segmod, t1;
  Point3 proj;

  dirseg.x = (P2.x - P1.x);
  dirseg.y = (P2.y - P1.y);
  dirseg.z = (P2.z - P1.z);
  // dirseg.z=0.0;
  segmod = V3Dot (&dirseg, &dirseg);

  t1 = -1.0;
  if ( segmod < (Eps * Eps)) {
      *dist = V3DistanceBetween2Points(&P1, &pto);
      memcpy(&proj,&P1,sizeof(Point3));
      t1 = 0.0; (*t)=t1;
      return(1);
  } else {
    dircross.x = pto.x - P1.x;
    dircross.y = pto.y - P1.y;
    dircross.z = pto.z - P1.z;
    //dircross.z=0.0;
    (t1) = V3Dot (&dirseg, &dircross ) / segmod;    
    proj.x = P1.x + (t1) * dirseg.x;
    proj.y = P1.y + (t1) * dirseg.y;
    proj.z = P1.z + (t1) * dirseg.z;

    (*dist) = V3DistanceBetween2Points(&proj, &pto);
    (*t)=t1;
    return(1);
  }
}
///*--------------------------------------------------------------------
///  Nome: coord_barycentric  - verify whether two given points coincide.
///-----------------------------------------------------------------------*/
int coord_barycentric3(Point3 *V1, Point3 *V2, Point3 *V3, Point3 *P,
                       double *a, double *b, double *c) {
  
  double U[3], V[3], W[3], Det;

  U[0] = P->x - V3->x;
  V[0] = P->y - V3->y;
  W[0] = P->z - V3->z;
  U[1] = V1->x - V3->x;
  V[1] = V1->y - V3->y;
  W[1] = V1->z - V3->z;
  U[2] = V2->x - V3->x;
  V[2] = V2->y - V3->y;
  W[2] = V2->z - V3->z;

  Det = V[2]*U[1] - U[2]*V[1];

  if (Det != 0) {

    (*b) = (V[0]*U[1] - U[0]*V[1])/Det;
    (*a) = (U[0]*V[2] - U[2]*V[0])/Det;
    *c = 1-*a-*b;
  } else {
    Det = W[2]*U[1] - U[2]*W[1];
    if (Det != 0) {
      (*c) = (W[0]*U[1] - U[0]*W[1])/Det;
      (*a) = (U[0]*W[2] - U[2]*W[0])/Det;
      *b = 1-*a-*c;
    } else {
      Det = W[2]*V[1] - V[2]*W[1];
      (*c) = (W[0]*V[1] - V[0]*W[1])/Det;
      (*b) = (V[0]*W[2] - V[2]*W[0])/Det;
      *a = 1-*b-*c;
    }
  }
  return(1);
}
///*--------------------------------------------------------------------
///  Nome: coord_baryc  - verify whether two given points coincide.
///-----------------------------------------------------------------------*/
int coord_baryc(Point2 *V1, Point2 *V2, Point2 *V3, Point2 *P,
                       double *a, double *b, double *c) {
  
  double U[3], V[3], Det;

  U[0] = P->x - V3->x;
  V[0] = P->y - V3->y;
  U[1] = V1->x - V3->x;
  V[1] = V1->y - V3->y;
  U[2] = V2->x - V3->x;
  V[2] = V2->y - V3->y;

  Det = V[2]*U[1] - U[2]*V[1];

  if (Det==0) Det=Eps;
  if (Det != 0) {
    (*b) = (V[0]*U[1] - U[0]*V[1])/Det;
    (*a) = (U[0]*V[2] - U[2]*V[0])/Det;
    *c = 1-*a-*b;
  } else {
    printf (" \n Erro... Agora nao sei como determinar" );
  }
  return(1);
}
/*----------------------------------------------------------------------
 	Nome: area_triangulo - determina a area de uma face  triangular
-----------------------------------------------------------------------*/
int area_triangulo(Point3 p0, Point3 p1, Point3 p2, double *area) {

  Point3 v1,v2, v1v2;
  
  V3Sub(&(p1),&(p0),&v1);
  V3Sub(&(p2),&(p0),&v2);
  V3Cross(&v1,&v2,&v1v2);
  (*area) = (V3Length(&v1v2))/2;
  return(1);
}
/*----------------------------------------------------------------------
        Nome: Vetcross_vert_face - determina o vetor paralelo ao vetor 
                                   normal da face.
-----------------------------------------------------------------------*/
int Vetcross_vert_face(int face, Vector3 *v1v2) {
  int qtyL, *loopList;
  int i, qty, *listvert;
  Vertice *V[3];
  Vector3 v1,v2;
  
  qtyL=0; loopList=0; qty=0; listvert=0;
  TdFAGetAdjLoops(face, &qtyL, &loopList);
  TdLAGetBoundVertices(loopList[0], &qty, &listvert);
  if (qtyL) free((char *)loopList);
  qty--;
  if ( (qty - 3) ) {    
    printf("\n Erro!! Triangulo com %d vertices(Vetcross) \n",qty);
  }
  for ( i=0; i<qty; ++i ) {
    TdVAGetDataPtr(listvert[i],(void *)&V[i]);
  }
  if (qty) free((char *)listvert);
  V3Sub(&(V[1]->X),&(V[0]->X),&v1);
  V3Sub(&(V[2]->X),&(V[0]->X),&v2);
  V3Cross(&v1,&v2,v1v2);
  return(1);
}
/*----------------------------------------------------------------------
 	Nome: norface - determina o vetor normal a uma face triangular.
-----------------------------------------------------------------------*/
int norface(int face, Point3 *normalface) {
  Vector3 vetor;
  
  Vetcross_vert_face(face,&vetor);
  memcpy(normalface,(Point3 *)V3Normalize(&vetor),
         sizeof(Point3));
  return(1);
}

void indice_para_ponto_dist_registro (Point3 point,Indice *ind){
  double auxi[2], z;
  IntPoint2 I0, I1;
  int k,l;
  Img_cart *f;

  z=ROUND((point.y-array_orig[nvi-1][mediox][medioy]->X_orig.y)/Int2[nvi-1]);
  I1.x=mediox+(int)z;
  z=ROUND((point.x-array_orig[nvi-1][mediox][medioy]->X_orig.x)/Int[nvi-1]);
  I1.y=medioy+(int)z; 
  
  I0.x=X_MAX[nvi-1]*2;
  
  for (auxi[0]=MAXFLOAT, k=(I1.x-2); k>=0 && k<=X_MAX[nvi-1]  && k<=(I1.x+2) ; k++)
    for (l=(I1.y-2); l>=0 && l<=Y_MAX[nvi-1] && l<=(I1.y+2); l++){
      if (array_orig[nvi-1][k][l]){
        f=array_orig[nvi-1][k][l];
        //auxi[1]= V3DistanceBetween2Points(&(f->X),&(point));
        auxi[1]= sqrt(pow((f->X.x-point.x),2)+pow((f->X.y-point.y),2));
        if (auxi[1]< auxi[0]){
          auxi[0]=auxi[1];
          I0.x=k; I0.y=l;
        }
      }
    }
  
  if (I0.x<=X_MAX[nvi-1] && array_orig[nvi-1][I0.x][I0.y] ){
    (*ind).i=I0.x; (*ind).j=I0.y;
  }else{
    //     printf ("\n Erro, nao ha correspondente");
    (*ind).i=(*ind).j=-1;
  }
}

void indice_para_ponto_dist_registro3 (Point3 point,Indice *ind){

  double auxi[2], z;
  IntPoint2 I0, I1;
  int k,l,im,iM,jm,jM;
  Img_cart *f;

  z=ROUND((point.y-array_orig[nvi-1][mediox][medioy]->X_orig.y)/Int2[nvi-1]);
  I1.x=mediox+(int)z;
  z=ROUND((point.x-array_orig[nvi-1][mediox][medioy]->X_orig.x)/Int[nvi-1]);
  I1.y=medioy+(int)z; 
  
  I0.x=X_MAX[nvi-1]*2;

  im=I1.x-3; if (im<0) im=0;
  iM=I1.x+3; if (iM>X_MAX[nvi-1]) iM=X_MAX[nvi-1];
  jm=I1.y-3; if (jm<0) jm=0;
  jM=I1.y+3; if (jM>Y_MAX[nvi-1]) jM=Y_MAX[nvi-1];
  
   for (auxi[0]=MAXFLOAT, k=im; k<=iM; k++)
    for (l=jm; l<=jM; l++){
      if (array_orig[nvi-1][k][l]){
        f=array_orig[nvi-1][k][l];
        auxi[1]= V3DistanceBetween2Points(&(f->X),&(point));
        //auxi[1]= sqrt(pow((f->X.x-point.x),2)+pow((f->X.y-point.y),2));
        if (auxi[1]< auxi[0]){
          auxi[0]=auxi[1];
          I0.x=k; I0.y=l;
        }
      }
    }
  
  if (I0.x<=X_MAX[nvi-1] && array_orig[nvi-1][I0.x][I0.y] ){
    (*ind).i=I0.x; (*ind).j=I0.y;
  }else{
    //     printf ("\n Erro, nao ha correspondente");
    (*ind).i=(*ind).j=-1;
  }
}
void indice_para_ponto_dist_registro4 (Point3 point,Indice *ind){

  double auxi[2], z;
  IntPoint2 I0, I1;
  int k,l,im,iM,jm,jM;
  Img_cart *f;

  z=ROUND((point.y-array_orig[nvi-1][mediox][medioy]->X_orig.y)/Int2[nvi-1]);
  I1.x=mediox+(int)z;
  z=ROUND((point.x-array_orig[nvi-1][mediox][medioy]->X_orig.x)/Int[nvi-1]);
  I1.y=medioy+(int)z; 
  
  I0.x=X_MAX[nvi-1]*2;

  im=I1.x-4; if (im<0) im=0;
  iM=I1.x+4; if (iM>X_MAX[nvi-1]) iM=X_MAX[nvi-1];
  jm=I1.y-4; if (jm<0) jm=0;
  jM=I1.y+4; if (jM>Y_MAX[nvi-1]) jM=Y_MAX[nvi-1];
  
   for (auxi[0]=MAXFLOAT, k=im; k<=iM; k++)
    for (l=jm; l<=jM; l++){
      if (array_orig[nvi-1][k][l]){
        f=array_orig[nvi-1][k][l];
        //        auxi[1]= V3DistanceBetween2Points(&(f->X),&(point));
        auxi[1]= sqrt(pow((f->X.x-point.x),2)+pow((f->X.y-point.y),2));
        if (auxi[1]< auxi[0]){
          auxi[0]=auxi[1];
          I0.x=k; I0.y=l;
        }
      }
    }
  
  if (I0.x<=X_MAX[nvi-1] && array_orig[nvi-1][I0.x][I0.y] ){
    (*ind).i=I0.x; (*ind).j=I0.y;
  }else{
    //     printf ("\n Erro, nao ha correspondente");
    (*ind).i=(*ind).j=-1;
  }
}

void indice_para_ponto_dist_registro1 (Point3 point,Indice *ind){

  double auxi[2], z;
  IntPoint2 I0, I1;
  int k,l,im,iM,jm,jM;
  Img_cart *f;

  z=ROUND((point.y-array_orig[nvi-1][mediox][medioy]->X_orig.y)/Int2[nvi-1]);
  I1.x=mediox+(int)z;
  z=ROUND((point.x-array_orig[nvi-1][mediox][medioy]->X_orig.x)/Int[nvi-1]);
  I1.y=medioy+(int)z; 
  
  I0.x=X_MAX[nvi-1]*2;

  im=I1.x-1; if (im<0) im=0;
  iM=I1.x+1; if (iM>X_MAX[nvi-1]) iM=X_MAX[nvi-1];
  jm=I1.y-1; if (jm<0) jm=0;
  jM=I1.y+1; if (jM>Y_MAX[nvi-1]) jM=Y_MAX[nvi-1];
  
   for (auxi[0]=MAXFLOAT, k=im; k<=iM; k++)
    for (l=jm; l<=jM; l++){
      if (array_orig[nvi-1][k][l]){
        f=array_orig[nvi-1][k][l];
        auxi[1]= V3DistanceBetween2Points(&(f->X),&(point));
        //auxi[1]= sqrt(pow((f->X.x-point.x),2)+pow((f->X.y-point.y),2));
        if (auxi[1]< auxi[0]){
          auxi[0]=auxi[1];
          I0.x=k; I0.y=l;
        }
      }
    }
  
  if (I0.x<=X_MAX[nvi-1] && array_orig[nvi-1][I0.x][I0.y] ){
    (*ind).i=I0.x; (*ind).j=I0.y;
  }else{
    //     printf ("\n Erro, nao ha correspondente");
    (*ind).i=(*ind).j=-1;
  }
}

void indice_para_ponto_dist_vertice (Point3 point,Indice *ind){

  double auxi[2], z;
  IntPoint2 I0, I1;
  int k,l,im,iM,jm,jM;
  Img_cart *f;

  z=ROUND((point.y-array_orig[nvi-1][mediox][medioy]->X_orig.y)/Int2[nvi-1]);
  I1.x=mediox+(int)z;
  z=ROUND((point.x-array_orig[nvi-1][mediox][medioy]->X_orig.x)/Int[nvi-1]);
  I1.y=medioy+(int)z; 
  
  I0.x=X_MAX[nvi-1]*2; (*ind).i=-1;

  im=I1.x-4; if (im<0) im=0;
  iM=I1.x+4; if (iM>X_MAX[nvi-1]) iM=X_MAX[nvi-1];
  jm=I1.y-4; if (jm<0) jm=0;
  jM=I1.y+4; if (jM>Y_MAX[nvi-1]) jM=Y_MAX[nvi-1];
  
  for (auxi[0]=MAXFLOAT, k=im; k<=iM; k++)
    for (l=jm; l<=jM; l++){
      if (array_orig[nvi-1][k][l] && array_orig[nvi-1][k][l]->pto_mdl){
        f=array_orig[nvi-1][k][l];
        auxi[1]= V3DistanceBetween2Points(&(f->X),&(point));
        //auxi[1]= sqrt(pow((f->X.x-point.x),2)+pow((f->X.y-point.y),2));
        if (auxi[1]< auxi[0]){
          auxi[0]=auxi[1];
          I0.x=k; I0.y=l;
        }
      }
    }
  
  if (I0.x<=X_MAX[nvi-1] && array_orig[nvi-1][I0.x][I0.y] ){
    (*ind).i=I0.x; (*ind).j=I0.y;
  }else{
    //      printf ("\n Erro, nao ha correspondente");
    (*ind).i=(*ind).j=-1;
  }
}
void indice_para_ponto_dist5 (Point3 point,Indice *ind){

  double auxi[2], z;
  IntPoint2 I0, I1;
  int k,l;
  Img_cart *f;

  z=ROUND((point.y-array_orig[nvi-1][mediox][medioy]->X.y)/Int2[nvi-1]);
  I1.x=mediox+(int)z;
  z=ROUND((point.x-array_orig[nvi-1][mediox][medioy]->X.x)/Int[nvi-1]);
  I1.y=medioy+(int)z; 
  
  I0.x=X_MAX[nvi-1]*2;
  
  for (auxi[0]=MAXFLOAT, k=(I1.x-6); k>=0 && k<=X_MAX[nvi-1]  && k<=(I1.x+6) ; k++)
    for (l=(I1.y-6); l>=0 && l<=Y_MAX[nvi-1] && l<=(I1.y+6); l++){
      if (array_orig[nvi-1][k][l]){
        f=array_orig[nvi-1][k][l];
        auxi[1]= V3DistanceBetween2Points(&(f->X),&(point));
        //auxi[1]= sqrt(pow((f->X.x-point.x),2)+pow((f->X.y-point.y),2));
        if (auxi[1]< auxi[0]){
          auxi[0]=auxi[1];
          I0.x=k; I0.y=l;
        }
      }
    }
  
  if (I0.x<=X_MAX[nvi-1] && array_orig[nvi-1][I0.x][I0.y] ){
    (*ind).i=I0.x; (*ind).j=I0.y;
  }else{
    //     printf ("\n Erro, nao ha correspondente");
    (*ind).i=(*ind).j=-1;
  }
}

void indice_para_ponto_sem_repet (Point3 point,Indice *ind){

  double auxi[2], z;
  IntPoint2 I0, I1;
  int k,l;
  Img_cart *f;

  z=ROUND((point.y-array_orig[nvi-1][mediox][medioy]->X.y)/Int2[nvi-1]);
  I1.x=mediox+(int)z;
  z=ROUND((point.x-array_orig[nvi-1][mediox][medioy]->X.x)/Int[nvi-1]);
  I1.y=medioy+(int)z; 
  
  I0.x=X_MAX[nvi-1]*2;
  
  for (auxi[0]=MAXFLOAT, k=(I1.x-3); k>=0 && k<=X_MAX[nvi-1] && k<=(I1.x+3) ; k++)
    for (l=(I1.y-3); l>=0 && l<=Y_MAX[nvi-1] && l<=(I1.y+3); l++){
      if (array_orig[nvi-1][k][l] && !array_orig[nvi-1][k][l]->pto_mdl){
        f=array_orig[nvi-1][k][l];
       auxi[1]= V3DistanceBetween2Points(&(f->X),&(point));
       // auxi[1]= sqrt(pow((f->X.x-point.x),2)+pow((f->X.y-point.y),2));
        if (auxi[1]< auxi[0]){
          auxi[0]=auxi[1];
          I0.x=k; I0.y=l;
        }
      }
    }
  
  if (I0.x<=X_MAX[nvi-1] && array_orig[nvi-1][I0.x][I0.y] ){
    (*ind).i=I0.x; (*ind).j=I0.y;
  }else{
    //     printf ("\n Erro, nao ha correspondente");
    (*ind).i=(*ind).j=-1;
  }
}

/*------------------------------------------------------*/
int dmax_dmin(double n1, double n2, double n3,
                double *max, double *min, double *c) {

  if ( n1 < n2 ) {
    if ( n1 < n3 ) {
      if ( n2 < n3 ) { (*max)  = n3; (*min)  = n1; (*c)=n2; }
      else { (*max)  = n2; (*min)  = n1;  (*c)=n3;}  }
    else { (*max)  = n2; (*min)  = n3;  (*c)=n1;}  }
  else { if ( n1 < n3 ) { (*max)  = n3; (*min)  = n2;  (*c)=n1;}
  else { if ( n2 < n3 ) { (*max)  = n1; (*min)  = n2; (*c)=n3; }
  else { (*max)  = n1; (*min)  = n3;  (*c)=n2;} }
  }
  return(1);
}
  
/******************************************************
 *    Funcoes usadas para manusear a imagem           *
 *                                                    * 
 ******************************************************/
int init_image_array(void) {
  int i, j;
  
  for (i=0; i< X_MAX[nvi-1]; i++)
    for (j=0; j< Y_MAX[nvi-1]; j++) {
      array_orig[nvi-1][i][j] = 0;
    }
  return(1);
}

/*----------------------------------------------------------------------
///  Nome: altura_face - get the height of a face with regard to the largest
///                      edge.
---------------------------------------------------------------------*/
double altura_face(Point3 p0, Point3 p1, Point3 p2) {
  int i, ind;
  double length, len;
  Vector3 tmp, p0p1, p0p2;
  Point3 V[3];

  memcpy (&(V[0]), &(p0), sizeof(Point3));
  memcpy (&(V[1]), &(p1), sizeof(Point3));
  memcpy (&(V[2]), &(p2), sizeof(Point3));
  
  for (length=-MAXFLOAT, i = 0; i<3; i++ ) {
    p0.x = V[i].x; p0.y = V[i].y; p0.z = V[i].z; 
    p1.x = V[(i+1)%3].x; p1.y = V[(i+1)%3].y;  p1.z = V[(i+1)%3].z;
    V3Sub(&p1, &p0, &tmp);
    len = V3Length(&tmp);
    if ( len > length ) {
      length = len;
      ind = i;
    }
  }

  p0.x = V[ind].x; p0.y = V[ind].y; p0.z = V[ind].z;   
  p1.x = V[(ind+1)%3].x; p1.y = V[(ind+1)%3].y; p1.z = V[(ind+1)%3].z;  
  V3Sub(&p1,&p0,&p0p1);
  len = V3Length(&p0p1);

  p1.x = V[(ind+2)%3].x; p1.y = V[(ind+2)%3].y; p1.z = V[(ind+2)%3].z;  
  V3Sub(&p1,&p0,&p0p2);
  V3Cross(&p0p1,&p0p2,&tmp);
  length = V3Length(&tmp);
  return(length/len);
}

/*----------------------------------------------------------------------
///  Nome: face_height - get the height of a face with regard to the largest
///                      edge.
---------------------------------------------------------------------*/
double face_height(int qty, int *listvert) {
  int i, ind;
  Vertice *V[3];
  double length, len /*, L1w, L1 */;
  Point3 p1, p0;
  Vector3 tmp, p0p1, p0p2;

  if (qty > 3) {
    printf("\n face_height: Chamada incorreta.");
    return(0.0);
  }

  for (length=-MAXFLOAT, i = 0; i<qty; i++ ) {
    TdVAGetDataPtr(listvert[i], (void *)&V[i]);
    TdVAGetDataPtr(listvert[(i+1)%3], (void *)&V[(i+1)%3]);
    /* Assume que a face tem vertices ancorados */
    p0.x = (V[i]->X).x; p0.y = (V[i]->X).y; p0.z = (V[i]->X).z; 
    p1.x = (V[(i+1)%3]->X).x; p1.y = (V[(i+1)%3]->X).y;
    p1.z = (V[(i+1)%3]->X).z;
    V3Sub(&p1, &p0, &tmp);
    len = V3Length(&tmp);
    if ( len > length ) {
      length = len;
      ind = i;
    }
  }
  TdVAGetDataPtr(listvert[(ind)%3], (void *)&V[0]);
  TdVAGetDataPtr(listvert[(ind+1)%3], (void *)&V[1]);
  TdVAGetDataPtr(listvert[(ind+2)%3], (void *)&V[2]);
  
  p0.x = (V[0]->X).x; p0.y = (V[0]->X).y; p0.z = (V[0]->X).z;   
  p1.x = (V[1]->X).x; p1.y = (V[1]->X).y; p1.z = (V[1]->X).z;  
  V3Sub(&p1,&p0,&p0p1);
  len = V3Length(&p0p1);

   p1.x = (V[2]->X).x; p1.y = (V[2]->X).y; p1.z = (V[2]->X).z;  
  V3Sub(&p1,&p0,&p0p2);
  V3Cross(&p0p1,&p0p2,&tmp);
  length = V3Length(&tmp);
  return(length/len);
}

/******************************************************************************
Transform point from meshes space to integrated range image space.
******************************************************************************/
void mesh_to_image(Matrix4 R,Point3 invec,Point3 *outvec){
  int j;
  double aux[3];

  for (j = 0; j < 3; j++)
    aux[j] = invec.x * R.element[0][j] + invec.y * R.element[1][j] +
	   invec.z * R.element[2][j];

  outvec->x = aux[0] - R.element[3][0];
  outvec->y = aux[1] - R.element[3][1];
  outvec->z = aux[2] - R.element[3][2];
}

/******************************************************************************
Transform point from integrated range image space to a meshes space.
******************************************************************************/
void image_to_mesh(Matrix4 R,Point3 invec,Point3 *outvec){
  int j;
  double aux[3];

  outvec->x = invec.x + R.element[3][0];
  outvec->y = invec.y + R.element[3][1];
  outvec->z = invec.z + R.element[3][2];

  for (j = 0; j < 3; j++)
    aux[j] = outvec->x * R.element[j][0] + outvec->y * R.element[j][1] +
	        outvec->z * R.element[j][2];
  
  outvec->x=aux[0]; outvec->y=aux[1]; outvec->z=aux[2];
}

/**************************************************************/
void MulPointByProjMatrix(Point3 *pin, Matrix4 *m, Point3 *pout){
  double w;
  pout->x = (pin->x * m->element[0][0]) + (pin->y * m->element[1][0]) + 
                 (pin->z * m->element[2][0]) + m->element[3][0];
  pout->y = (pin->x * m->element[0][1]) + (pin->y * m->element[1][1]) + 
    (pin->z * m->element[2][1]) + m->element[3][1];
  pout->z = (pin->x * m->element[0][2]) + (pin->y * m->element[1][2]) + 
    (pin->z * m->element[2][2]) + m->element[3][2];
  w =    (pin->x * m->element[0][3]) + (pin->y * m->element[1][3]) + 
    (pin->z * m->element[2][3]) + m->element[3][3];
  if (w != 0.0) { pout->x /= w;  pout->y /= w;  pout->z /= w; }
}

/* transpose matrix a, return b */
void TransposeMatrix(Matrix4 *a, Matrix4 *b){
int i, j;
        for (i=0; i<3; i++) {
                for (j=0; j<3; j++)
                  b->element[i][j] = a->element[j][i];
        }
}

void MatMul(Matrix4 *a, Matrix4 *b, Matrix4 *c){
int i, j, k;
 for (i=0; i<3; i++) {
   for (j=0; j<3; j++) {
     c->element[i][j] = 0;
     for (k=0; k<3; k++) c->element[i][j] += 
                           a->element[i][k] * b->element[k][j];
     
   }
 }
}

int imax_imin(int n1, int n2, int n3, int *max, int *min, int *c) {

  if ( n1 < n2 ) {
    if ( n1 < n3 ) {
      if ( n2 < n3 ) { (*max)  = n3; (*min)  = n1; (*c)=n2;}
      else { (*max)  = n2; (*min)  = n1; (*c)=n3;}  }
    else { (*max)  = n2;  (*min)  = n3; (*c)=n1;}  }
  else { if ( n1 < n3 ) { (*max)  = n3; (*min)  = n2;(*c)=n1; }
  else { if ( n2 < n3 ) { (*max)  = n1; (*min)  = n2;(*c)=n3; }
  else {  (*max)  = n1; (*min)  = n3; (*c)=n2;} }
  }
  return(1);
}

int orienta_aresta(int aux, int *ve0, int *ve1){
  
   int qtyL, qtyV1, *loopList, *listV1, k, aux2;
   qtyL = 0; loopList = 0; qtyV1 = 0; listV1 = 0;
   TdFAGetAdjLoops(aux, &qtyL, &loopList);
   TdLAGetBoundVertices(loopList[0], &qtyV1, &listV1);
   free((char *)loopList);
   qtyV1--;
   
   /* swap the extreme vertices of <edge>  to ensure correct orientation */
   for (k=0; k< qtyV1; k++) {
     if (listV1[k] == *(ve0)) {
       if (listV1[(k+1)%(qtyV1)] != *(ve1)) {
	 aux2=*ve0; *ve0=*ve1; *ve1=aux2;
       }
       k = qtyV1;
     }
   }   
   return (1);
 }

/******************************************************************************
Convert a quaternion into a rotation matrix.
Entry:  q - quaternion = (x,y,z,w)
Exit:  mat - rotation matrix
******************************************************************************/
void convert_quat_to_mat(Quaternion q, Matrix4 *mat){
  float q00,q01,q02,q03;
  float q11,q12,q13;
  float q22,q23;
  float q33;
  
  q00 = q[0] * q[0]; q01 = q[0] * q[1]; q02 = q[0] * q[2]; q03 = q[0] * q[3];
  
  q11 = q[1] * q[1]; q12 = q[1] * q[2]; q13 = q[1] * q[3];
  
  q22 = q[2] * q[2]; q23 = q[2] * q[3];

  q33 = q[3] * q[3];
  
  mat->element[0][0] = q00 + q11 - q22 - q33;
  mat->element[1][0] = 2 * (q12 - q03);
  mat->element[2][0] = 2 * (q13 + q02);
  mat->element[3][0] = 0;
  
  mat->element[0][1] =  2 * (q12 + q03);
  mat->element[1][1] =  q00 + q22 - q11 - q33;
  mat->element[2][1] = 2 * (q23 - q01);
  mat->element[3][1] = 0;

  mat->element[0][2] = 2 * (q13 - q02);
  mat->element[1][2] = 2 * (q23 + q01);
  mat->element[2][2] = q00 + q33 - q11 - q22;
  mat->element[3][2] = 0;
  
  mat->element[0][3] = 0;
  mat->element[1][3] = 0;
  mat->element[2][3] = 0;
  mat->element[3][3] = 1;
}

void update_mesh(Matrix4 R){
  
  int j;

  for (j=0;  j<nvertfacessimp[nvi-2].i;   j++) 
    mesh_to_image(R, vertices[nvi-2][j].X, &(vertices[nvi-2][j].X));
  
}
void retrieve_mesh(void){

  int j;
  
  for (j=0;  j<nvertfacessimp[nvi-2].i;   j++) 
    memcpy(&(vertices[nvi-2][j].X), &(vertices[nvi-2][j].X_orig),
           sizeof(Point3));
  
}

void update_sample_data(Matrix4 R){

  int i,j;
  Img_cart *f;
  
  /*  int qtyV, *listvert,j;
  Vertice *Point;

  qtyV = 0; listvert = 0; 
  TdOAGetVertices(Obj, &qtyV, &listvert);
  for (j=0;  j<qtyV;   j++) {
    TdVAGetDataPtr(listvert[j], (void *)&Point);    
    memcpy(&(array_orig[Point->vista]
                    [Point->indI.i][Point->indI.j]->X_orig), &(Point->X), sizeof(Point3));
  }
  if (qtyV) free ((char *)listvert);*/
  for (i=0; i<X_MAX[nvi-2]; i++)
    for (j=0; j<Y_MAX[nvi-2]; j++){
      f=array_orig[nvi-2][i][j];
      if (f){
        mesh_to_image(R, f->X_orig, &(f->X_orig));
        memcpy (&(f->X),&(f->X_orig), sizeof(Point3));

      }
    }
}

int vizinhanca_de_frente (Point3 vert, Point3 *Pgon, int nro_v){
  Point3 normal;
  int i;
  Vector3 v1,v2;

  for (i=0; i<nro_v;i++){
    V3Sub(&(Pgon[i]),&(vert),&v1);
    V3Sub(&(Pgon[(i+1)%nro_v]),&(vert),&v2);
    V3Cross(&v1,&v2,&(normal));
    V3Normalize(&normal);
    if (normal.z<-Eps){
      return(0);
    }
  }
  return(1);
}
/*--------------------------------------------------------------------
///	Nome: insere_list_ord: insere em uma lista dupla ordenada.
///     Parametro : lista (i/o) - listas dos pontos ordenados.
///                 pto (i) - novo ponto a ser inserido.
///-------------------------------------------------------------------*/
int insere_list_ord(struct Listdist **lista,double dist,int i) {
  int flag;
  struct Listdist *p, *t,*tt;
  
  p=0; flag=0;
  p = (struct Listdist *)malloc(sizeof(struct Listdist)); 
  p->d = dist;
  p->i = i;
  if ( (*lista) ) {
    for ( flag=1,tt=0,t=(*lista); t && flag; tt=t, t=t->prox ) {
      if ( p->d < t->d ){
	flag = 0; 
	p->prox = t;
	p->ant = t->ant;
	if ( t->ant ) (t->ant)->prox = p;
	else  (*lista) = p;
	t->ant = p;
      }
    }
    if ( flag ) {
      p->prox = t;  
      p->ant = tt;
      tt->prox = p;
    }
  } else { 
    p->prox = 0;
    p->ant = 0;
    (*lista) = p;
  }
  return(1);
}

void acha_normal(Point3 *Pgon, int qty, Point3 *normal ){
  int i,j,k;
  Point3 c1,c2;
  float v1[3],v2[3];
  Matrix3 cov;
  
  gsl_matrix *M = gsl_matrix_alloc (3, 3);
  gsl_vector *eval = gsl_vector_alloc (3);
  gsl_matrix *evec = gsl_matrix_alloc (3, 3);
  
  gsl_eigen_symmv_workspace * w =   gsl_eigen_symmv_alloc (3);
  
  c1.x = c1.y = c1.z = c2.x = c2.y = c2.z = 0;
  
  /* center of mass for two point collections */
  
  for (i = 0; i < qty; i++) {
    c1.x += Pgon[i].x; c1.y += Pgon[i].y; c1.z += Pgon[i].z;
    c2.x += Pgon[i].x; c2.y += Pgon[i].y; c2.z += Pgon[i].z;
  }
  
  c1.x = c1.x/qty; c1.y = c1.y/qty; c1.z = c1.z/qty;
  c2.x = c2.x/qty; c2.y = c2.y/qty; c2.z = c2.z/qty;
  
  /* create the cross-covariance matrix */
  
  for (i = 0; i < 3; i++)
    for (j = 0; j < 3; j++)
      cov.element[i][j] = 0;
  
  for (k = 0; k < qty; k++) {
    
    v1[0] = (Pgon[k].x - c1.x); v1[1] = (Pgon[k].y - c1.y);
    v1[2] = (Pgon[k].z - c1.z);
    
    v2[0] = Pgon[k].x - c2.x; v2[1] = Pgon[k].y - c2.y;
    v2[2] = Pgon[k].z - c2.z;
    
    for (i=0;i<3;i++)
      for (j = 0; j < 3; j++)
        cov.element[i][j]+=v1[i]*v2[j];
  }  

  /* create the necessary 3x3 matrix */
  
  for (i = 0; i < 3; i++)
    for (j = 0; j < 3; j++)
      gsl_matrix_set
         (M, i, j, cov.element[i][j]/qty);
  
   /* find the eigenvector corresponding to the largest eigenvalue */
   /* of this matrix */
  
  gsl_eigen_symmv (M, eval, evec, w);

  gsl_eigen_symmv_free(w);
  
  gsl_eigen_symmv_sort (eval, evec, GSL_EIGEN_SORT_VAL_DESC);
  
  /* Pega o autovetor correspondente ao menor autovalor */
  
  (*normal).x =  gsl_matrix_get (evec, 0, 2);
  (*normal).y =  gsl_matrix_get (evec, 1, 2);
  (*normal).z =  gsl_matrix_get (evec, 2, 2);
  
  gsl_matrix_free (M);
  gsl_vector_free (eval);
  gsl_matrix_free (evec);
}

void comprimento_aresta_malha (double *lim){
  double *data;
  int qtyf, *listf, qtye, *liste,red,j;
     
  qtye = 0; liste = 0;
  TdOAGetEdges(Obj, &qtye, &liste);
  for (red=j=0;  j<qtye ; j++) {
    qtyf=0;listf=0;
    TdEAGetAdjFaces(liste[j], &qtyf, &listf);
    if (qtyf>1){
      if (!(red)){
        data = (double *) malloc(sizeof (double)); red++;}
      else
        data = (double *) realloc (data, sizeof (double) * (++(red)));
      
      data[red-1]=length_edge(liste[j]);
    }
  }
  gsl_sort (data, 1, red);
  
  *lim = gsl_stats_quantile_from_sorted_data (data, 1, red, 0.5);
 
  if (red) free ((char *)data);
  if (qtyf) free ((char *)listf);
  if (qtye) free ((char *)liste);
}

/*************************************************************************
                       Initialize the list of pairs.
**************************************************************************/
void init_pairs(){
  int i;

  if (pairs != NULL) {
    for (i = 0; i < npairs; i++)  free (pairs[i]);
    free (pairs);
  }
  npairs = 0;  max_pairs = 3;
  pairs = (Pair **) malloc (sizeof (Pair *) * max_pairs);
}
/****************************************************************************
Add a pair to the list of pairs. Entry:p1,p2-pair of corresponding points
*****************************************************************************/
void add_pair(Point3 p1, Point3 p2){
  Pair *new;

  if (npairs >= max_pairs) {
    max_pairs *= 2;
    pairs = (Pair **) realloc (pairs, sizeof (Pair *) * max_pairs);
  }
  new = (Pair *) malloc(sizeof (Pair));
  pairs[npairs] = new;  npairs++;

  new->p1.x = p1.x; new->p1.y = p1.y; new->p1.z = p1.z;
  new->p2.x = p2.x; new->p2.y = p2.y; new->p2.z = p2.z;
}
/******************************************************************************
Find the best rotation and translation to match two collections of points.
The set of all first elements from the pairs is one collection of points,
and the second elements forms the other collection.

Exit:  R   - matrix with the best rotation and translation for the match
       t   - translational component
******************************************************************************/
void match_pairs(Matrix4 *R, int npa){

  int i,j,k;
  double tr;
  Quaternion q_rot;
  Point3 c1,c2,t;
  float v1[3],v2[3];
  Matrix3 cov, aij;

  gsl_matrix *M = gsl_matrix_alloc (4, 4);
  gsl_vector *eval = gsl_vector_alloc (4);
  gsl_matrix *evec = gsl_matrix_alloc (4, 4);

  gsl_eigen_symmv_workspace * w = 
  gsl_eigen_symmv_alloc (4);
  
  c1.x = c1.y = c1.z = c2.x = c2.y = c2.z = 0;
  
  /* center of mass for two point collections */
  
  for (i = 0; i < npa; i++) {
    c1.x += pairs[i]->p1.x; c1.y += pairs[i]->p1.y; c1.z += pairs[i]->p1.z;
    c2.x += pairs[i]->p2.x; c2.y += pairs[i]->p2.y; c2.z += pairs[i]->p2.z;
  }
  
  c1.x = c1.x/npa; c1.y = c1.y/npa; c1.z = c1.z/npa;
  c2.x = c2.x/npa; c2.y = c2.y/npa; c2.z = c2.z/npa;
  
  /* create the cross-covariance matrix */
  
  for (i = 0; i < 3; i++)
    for (j = 0; j < 3; j++)
      cov.element[i][j] = 0;
  
  for (k = 0; k < npa; k++) {

    v1[0] = (pairs[k]->p1.x - c1.x); v1[1] = (pairs[k]->p1.y - c1.y);
    v1[2] = (pairs[k]->p1.z - c1.z);

    v2[0] = pairs[k]->p2.x - c2.x; v2[1] = pairs[k]->p2.y - c2.y;
    v2[2] = pairs[k]->p2.z - c2.z;

    for (i=0;i<3;i++)
      for (j = 0; j < 3; j++)
        cov.element[i][j]+=v1[i]*v2[j];
  }  
    /* aij = cov - transpose(cov) */
    
    for (i = 0; i < 3; i++)
      for (j = 0; j < 3; j++)
        aij.element[i][j] = cov.element[i][j] - cov.element[j][i];

    /* find the trace of the covariance matrix */
    
    tr = cov.element[0][0] + cov.element[1][1] + cov.element[2][2];

    /* create the necessary 4x4 matrix */

    gsl_matrix_set (M, 0, 0, tr);
    
    gsl_matrix_set (M, 1, 0, aij.element[1][2]);
    gsl_matrix_set (M, 0, 1, aij.element[1][2]);
    gsl_matrix_set (M, 2, 0, aij.element[2][0]);
    gsl_matrix_set (M, 0, 2, aij.element[2][0]);
    gsl_matrix_set (M, 3, 0, aij.element[0][1]);
    gsl_matrix_set (M, 0, 3, aij.element[0][1]);
    
    for (i = 0; i < 3; i++)
      for (j = 0; j < 3; j++)
         gsl_matrix_set
          (M, i+1, j+1, cov.element[i][j] + cov.element[j][i] - (i == j) * tr);
    /* find the eigenvector corresponding to the largest eigenvalue */
    gsl_eigen_symmv (M, eval, evec, w);

    gsl_eigen_symmv_free(w);
    
    gsl_eigen_symmv_sort (eval, evec, GSL_EIGEN_SORT_VAL_DESC);

    for (i=0;i<4;i++)
      q_rot[i] =  gsl_matrix_get (evec, i, 0);

    gsl_matrix_free (M);
    gsl_vector_free (eval);
    gsl_matrix_free (evec);
    
    convert_quat_to_mat (q_rot, R);
    
    /* determine best translation */
    V3MulPointByMatrix(&c1,R);
    V3Sub(&c1,&c2,&t);
    R->element[3][0]=t.x;R->element[3][1]=t.y;
    R->element[3][2]=t.z;R->element[3][3]=1.0;

    //    memcpy(q,&(q_rot),sizeof(Quaternion));
    //    memcpy(tra,&t,sizeof(Point3));
}

int le_imagem() {
  double z,minx, miny,xmed,ymed, cont, somInt, temp, cc;
  int  lx, ly, item; 
  struct imag_cart *f;
  FILE  *arq;
  extern double xmin,xMax,ymin,yMax,zmin,zMax,*raio,*raiomenor,*raiomeio,cx_mod,cy_mod,cz_mod;
     
  xMax = yMax = zMax = -MAXFLOAT; xmin = ymin = zmin = MAXFLOAT;

  if (nvi>1){
    X_MAX = (int *)realloc (X_MAX, sizeof(int)*nvi);
    Y_MAX = (int *)realloc (Y_MAX, sizeof(int)*nvi);
    raio = (double *)realloc (raio, sizeof(double)*nvi);
    raiomenor = (double *)realloc (raiomenor, sizeof(double)*nvi);
  
  }
  
  
  item=1; /* Segunda, terceira .... imagem */
  if (nvi==1) /* Primeira imagem */
    item=0;
  
   ///    Le o arquivo que contem a imagem;
  
  /* Os arquivos txt (MINOLTA) e rif (STTURGART) tem 4 imagens
     a diferenca e que txt tem a imagem flag de entradas validas no inicio e
     rif tem no final */

  /* Quando o arquivo e ply (range_grid) tem que passar primeiro por uma
     conversao de formato ply2txt (ver m_converte.c)*/

  
  printf(" Imagem ==> %s  da vista %d",imagem[nvi-1],nvi);
 
  if ( (arq = fopen(imagem[nvi-1],"r")) == NULL ) {
    printf("\n Arquivo 'ran' nao foi aberto!! \n\n");
    exit(1);
  }

  /* Atencao : Lemos primeiro colunas e depois linhas */

  fscanf(arq,"%d %d",&(Y_MAX[nvi-1]),&(X_MAX[nvi-1]));
  init_image_array();

  mediox=X_MAX[nvi-1]/2-1;
  medioy=Y_MAX[nvi-1]/2-1;
  
  /* Cria array_orig[nvi-1][ ][lx][ly] sempre que a entrada existe (flag=1)*/

  for (lx=0; lx<X_MAX[nvi-1]; lx++) {
    for (ly=0; ly<Y_MAX[nvi-1]; ly++){
      fscanf(arq,"%lf",&z);
      if ( z && z!=-999999){
	f =(struct imag_cart *)malloc(sizeof(struct imag_cart));
	if ( !f ) {
	  printf(" falha na solicitacao de memoria em f \n");
	  exit(1);
	}
	f->ind.i=lx; f->ind.j=ly;
        f->X.x = z; f->X.y = -1e3; f->X.z = -1e3;
        f->X_orig.x = z; f->X_orig.y = -1e3; f->X_orig.z = -1e3;
        f->pto_mdl = 0;  f->borda = 0;   f->dist = -1e3;
        f->normal.x=f->normal.y=f->normal.z=0.0;f->misto = 0; 
        f->id_face=0;  f->redund= 0; array_orig[nvi-1][lx][ly] = f;
	(NUM_PTOS[item])++;
      }
    }
  }

  printf("\n Numero de Pontos = %d, imagem(%d,%d) ", NUM_PTOS[item], Y_MAX[nvi-1],X_MAX[nvi-1]);
 
  /// Em cada entrada valida insere os valores (X,Y,Z)
  /// i (linha/ associado com y e j/coluna associado com x)
  
  for (lx=0; lx<X_MAX[nvi-1]; lx++) {
    for (ly=0; ly<Y_MAX[nvi-1]; ly++){
      fscanf(arq,"%lf",&z);
      if ( array_orig[nvi-1][lx][ly] ){
	f=array_orig[nvi-1][lx][ly];
        if (!rif){
          f->X.x = z; f->X_orig.x = f->X.x;
        }else{
           f->X.y = z; f->X_orig.y = f->X.y;
        }
      }
    }
  }
  
  for (lx=0; lx<X_MAX[nvi-1]; lx++) {
    for (ly=0; ly<Y_MAX[nvi-1]; ly++){
     fscanf(arq,"%lf",&z);
      if ( array_orig[nvi-1][lx][ly] ){
	f=array_orig[nvi-1][lx][ly];
        if (!rif){
          f->X.y = z; f->X_orig.y = f->X.y;
        }else{
          f->X.z = z; f->X_orig.z = z;
        }
      }
    }
  }
  
  if (!rif)
    for (lx=0; lx<X_MAX[nvi-1]; lx++) {
      for (ly=0; ly<Y_MAX[nvi-1]; ly++){
        fscanf(arq,"%lf",&z);
        if ( array_orig[nvi-1][lx][ly] ){
          f=array_orig[nvi-1][lx][ly];
          f->X.z = z; f->X_orig.z = z;
        }
      }
    }
  
  for (lx=0; lx<X_MAX[nvi-1]; lx++) {
    for (ly=0; ly<Y_MAX[nvi-1]; ly++){
      if ( array_orig[nvi-1][lx][ly] ){
        f=array_orig[nvi-1][lx][ly];
        if (xmin > f->X.x) xmin = f->X.x;  if (xMax < f->X.x) xMax = f->X.x;
        if (ymin > f->X.y) ymin = f->X.y;  if (yMax < f->X.y) yMax = f->X.y;
        if (zmin > f->X.z) zmin = f->X.z;  if (zMax < f->X.z) zMax = f->X.z;
      }
    }
  }

  fclose(arq);
  printf ("\n ORIGINAIS");
  printf("\n Mx = %f, mx = %f",xMax,xmin);
  printf("\n My = %f, my = %f ",yMax,ymin);
  printf("\n Mz = %f,  mz = %f ",zMax,zmin);

  /* Procura o centro da imagem */

  xmed=(xMax+xmin)/2;
  ymed=(yMax+ymin)/2;
  
  for (minx=miny=MAXFLOAT,lx=0; lx<X_MAX[nvi-1]; lx++) {
    for (ly=0; ly<Y_MAX[nvi-1]; ly++){   
      if ( array_orig[nvi-1][lx][ly] ){
        f=array_orig[nvi-1][lx][ly];
	temp=sqrt(pow(f->X.x-xmed,2)+ pow(f->X.y-ymed,2));
        if (temp<minx){
          minx=temp;
	  mediox=lx;
          medioy=ly;
        }
      }
    }
  }
  
  IntMAX=-MAXFLOAT;
  
  for (somInt=0.0,lx=0; lx<X_MAX[nvi-1]; lx++) {
    for (ly=0; ly<Y_MAX[nvi-1]-1; ly++){   
      if ( array_orig[nvi-1][lx][ly] && array_orig[nvi-1][lx][ly+1]){
        Int[nvi-1]=(array_orig[nvi-1][lx][ly+1]->X.x-array_orig[nvi-1][lx][ly]->X.x);
        somInt+=Int[nvi-1];
        cont++;
        if (fabs(Int[nvi-1])>IntMAX)
          IntMAX=fabs(Int[nvi-1]);
      }
    }
  }
  
  Int[nvi-1]=somInt/cont;
  
  Int[nvi-1]=floor(Int[nvi-1] * 1000 + 0.5) / 1000;
 
  for (somInt=0.0,cont=ly=0; ly<Y_MAX[nvi-1]; ly++) {
    for (lx=0; lx<X_MAX[nvi-1]-1; lx++){   
      if ( array_orig[nvi-1][lx][ly] && array_orig[nvi-1][lx+1][ly]){
        Int2[nvi-1]=(array_orig[nvi-1][lx+1][ly]->X.y-array_orig[nvi-1][lx][ly]->X.y);
        somInt+=Int2[nvi-1];
        cont++;
        if (fabs(Int2[nvi-1])>IntMAX)
          IntMAX=fabs(Int2[nvi-1]);
      }
    }
  }
  
  Int2[nvi-1]=somInt/cont;
  Int2[nvi-1]=floor(Int2[nvi-1] * 1000 + 0.5) / 1000;

  item=1;
  if (nvi==1)
    item=0;
  maxInts[item]=fabs(Int[nvi-1]);
  if (fabs(Int2[nvi-1])>maxInts[item])
    maxInts[item]=fabs(Int2[nvi-1]);

  // Atencao ::: Verificar este for
  
 for (;!array_orig[nvi-1][mediox][medioy] && mediox>=0;mediox--);
  if (!array_orig[nvi-1][mediox][medioy])
    for ( ;!array_orig[nvi-1][mediox][medioy] && mediox<=X_MAX[nvi-1];mediox++);

   
  
  // xMax = yMax = zMax = -MAXFLOAT; xmin = ymin = zmin = MAXFLOAT;
  for (lx=0; lx<X_MAX[nvi-1]; lx++) {
    for (ly=0; ly<Y_MAX[nvi-1]; ly++){   
      if ( array_orig[nvi-1][lx][ly] ){
        f=array_orig[nvi-1][lx][ly];
        //        f->X_orig.x = (ly-medioy)*Int;  //f->X_orig.x = f->X.x;
        //f->X_orig.y = (lx-mediox)*Int2; //f->X_orig.y = f->X.y;
        /*if (xmin > f->X.x) xmin = f->X.x;  if (xMax < f->X.x) xMax = f->X.x;
        if (ymin > f->X.y) ymin = f->X.y;  if (yMax < f->X.y) yMax = f->X.y;
        if (zmin > f->X.z) zmin = f->X.z;  if (zMax < f->X.z) zMax = f->X.z;*/
      }
    }
  }
  
  printf ("\n NOVO CENTRO");
  printf("\n Mx = %f, mx = %f ",xMax,xmin);
  printf("\n My = %f, my = %f ",yMax,ymin);
  printf("\n Mz = %f,  mz = %f ",zMax,zmin);

  // Calculo do raio da esfera que contera e mostrara a imagem 

  cx_mod=xMax+(xmin-xMax)/2;
  cy_mod=yMax+(ymin-yMax)/2;
  cz_mod =zMax+(zmin-zMax)/2;
  dmax_dmin(fabs(xmin-xMax)/2, fabs(ymin-yMax)/2,fabs(zMax-zmin)/2,
            &raio[nvi-1], &raiomenor[nvi-1], &(raiomeio[nvi-1]));
  printf ("\n MAX compr. da Bounding Box da imagem %d : %1.2f ",nvi-1,2*raio[nvi-1]);
  
  printf("\n centro = ( %4.2f,%4.2f,%4.2f) ",cx_mod,cy_mod,cz_mod);

  return(1);
}

void indicesface (Indice3 **ind, int *co2, int a, int b, int c){

  (*ind)[*co2].i=a; (*ind)[*co2].j=b; (*ind)[(*co2)++].k=c;

}

void cria_malhas_densas_smfeply ( ){
  int li, lj,co,co2,item, lii, ljj,c ; 
  struct imag_cart *f,*g,*h, *i;
  FILE  *arq;
  double dist1,dist2, lim;
  Indice3 *indf;
  char string[20]="a", *pch;
  char key[]="0123456789";
  int num=3;

  lim=6*maxInts[nvi-1];
  item=1; /* Segunda, terceira .... imagem */
  if (nvi==1) /* Primeira imagem */
    item=0;

  /* Constroi nome do arquivo ply */
  /* O arquivo ply contera a estrutura da malha densa de imagem[nvi-1] */
  
  strncpy(string,imagem[nvi-1],3);
  pch=strpbrk(imagem[nvi-1],key);
  
  while (pch!=NULL){
    string[num++]= *pch;
    pch=strpbrk(pch+1,key);
  }
  strcat(string,".ply");
  
  if ( (arq = fopen(string,"w")) == NULL ) {
    printf("\n Arquivo 'ran' nao foi aberto!! \n\n");
    exit(1);
  }
   
  for (co=li=0; li<X_MAX[nvi-1]; li++) {
    for (lj=0; lj<Y_MAX[nvi-1]; lj++){
      f=array_orig[nvi-1][li][lj];
      if (f)
        f->misto=++co;
    }
  }
   
  indf =(Indice3 *)malloc(sizeof(Indice3)*X_MAX[nvi-1]*Y_MAX[nvi-1]);
  
  for (co2=li=0; li<X_MAX[nvi-1]; li++) {
    for (lj=0; lj<Y_MAX[nvi-1]; lj++){

      // 1 4  //f i
      // 2 3  //g h    Posicoes certas "na imagem"

      //3 2         |  2 3
      //4 1         |  1 4  formato ply
      //            |
      //------------------------
      //            |
      //4 1 formato |  1 4  formato txt
      //3 2  rif    |  2 3 
      //            |

      lii = (li + 1) % X_MAX[nvi-1];
      ljj = (lj + 1) % Y_MAX[nvi-1];

      f=array_orig[nvi-1][li][lj];  g=array_orig[nvi-1][lii][lj];
      h=array_orig[nvi-1][lii][ljj];i=array_orig[nvi-1][li][ljj];

      c = ((f!=0) + (g!=0) + (h!=0) + (i!=0));
      dist1=dist2=MAXFLOAT;
      if (f && h)  dist1=V3DistanceBetween2Points(&(f->X),&(h->X));
      if (g && i)  dist2=V3DistanceBetween2Points(&(g->X),&(i->X));

      if (c==4){
        if (Int[nvi-1]*Int2[nvi-1]<0) // Caso formato txt
          if (dist1<=dist2 ){
            if (dist1< lim) {
              if (V3DistanceBetween2Points(&(f->X),&(g->X))<lim &&
                  V3DistanceBetween2Points(&(g->X),&(h->X))<lim)
                indicesface(&indf,&co2,f->misto-1,g->misto-1,h->misto-1) ;
              if (V3DistanceBetween2Points(&(i->X),&(h->X))<lim &&
                  V3DistanceBetween2Points(&(i->X),&(f->X))<lim)
                indicesface(&indf,&co2,f->misto-1,h->misto-1,i->misto-1);
            }
          }else {
            if (dist2< lim){
              if (V3DistanceBetween2Points(&(g->X),&(h->X))<lim &&
                  V3DistanceBetween2Points(&(h->X),&(i->X))<lim)
                indicesface(&indf,&co2,g->misto-1,h->misto-1,i->misto-1);
              if (V3DistanceBetween2Points(&(f->X),&(i->X))<lim &&
                  V3DistanceBetween2Points(&(f->X),&(g->X))<lim)
              indicesface(&indf,&co2,g->misto-1,i->misto-1,f->misto-1);
            }
          }
        else // Casos formato ply e rif
          if (dist1<=dist2 ){
            if (dist1< lim) {
               if (V3DistanceBetween2Points(&(f->X),&(g->X))<lim &&
                   V3DistanceBetween2Points(&(g->X),&(h->X))<lim)
                 indicesface(&indf,&co2,f->misto-1,h->misto-1,g->misto-1);
               if (V3DistanceBetween2Points(&(i->X),&(h->X))<lim &&
                   V3DistanceBetween2Points(&(i->X),&(f->X))<lim)
                 indicesface(&indf,&co2,f->misto-1,i->misto-1,h->misto-1);
            }
          }else {
            if (dist2< lim){
              if (V3DistanceBetween2Points(&(g->X),&(h->X))<lim &&
                  V3DistanceBetween2Points(&(h->X),&(i->X))<lim)
                indicesface(&indf,&co2,g->misto-1,i->misto-1,h->misto-1);
              if (V3DistanceBetween2Points(&(f->X),&(i->X))<lim &&
                  V3DistanceBetween2Points(&(f->X),&(g->X))<lim)
                indicesface(&indf,&co2,g->misto-1,f->misto-1,i->misto-1);
            }
          }
      }else if (c==3){
        if (Int[nvi-1]*Int2[nvi-1]<0) // Caso formato txt
          if (dist1<=dist2 ){
            if (dist1< lim) {
              if (!i && V3DistanceBetween2Points(&(f->X),&(g->X))<lim &&
                  V3DistanceBetween2Points(&(g->X),&(h->X))<lim)
                indicesface(&indf,&co2,f->misto-1,g->misto-1,h->misto-1);
              else if (!g && V3DistanceBetween2Points(&(i->X),&(h->X))<lim &&
                       V3DistanceBetween2Points(&(i->X),&(f->X))<lim)
                indicesface(&indf,&co2,f->misto-1,h->misto-1,i->misto-1);
            }
          }else {
            if (dist2< lim){
              if (!f && V3DistanceBetween2Points(&(g->X),&(h->X))<lim &&
                  V3DistanceBetween2Points(&(h->X),&(i->X))<lim)
                indicesface(&indf,&co2,g->misto-1,h->misto-1,i->misto-1);
              else if (!h && V3DistanceBetween2Points(&(f->X),&(i->X))<lim &&
                       V3DistanceBetween2Points(&(f->X),&(g->X))<lim) 
                indicesface(&indf,&co2,g->misto-1,i->misto-1,f->misto-1);
            }
          }
        else // Casos formato ply e rif
          if (dist1<=dist2 ){
            if (dist1< lim) {
              if (!i && V3DistanceBetween2Points(&(f->X),&(g->X))<lim &&
                  V3DistanceBetween2Points(&(g->X),&(h->X))<lim)
                indicesface(&indf,&co2,f->misto-1,h->misto-1,g->misto-1);
              else if (!g && V3DistanceBetween2Points(&(i->X),&(h->X))<lim &&
                       V3DistanceBetween2Points(&(i->X),&(f->X))<lim)
                indicesface(&indf,&co2,f->misto-1,i->misto-1,h->misto-1);
            }
          } else {
            if (dist2< lim){
              if (!f && V3DistanceBetween2Points(&(g->X),&(h->X))<lim &&
                  V3DistanceBetween2Points(&(h->X),&(i->X))<lim )
                indicesface(&indf,&co2,g->misto-1,i->misto-1,h->misto-1);
              else if (!h && V3DistanceBetween2Points(&(f->X),&(i->X))<lim &&
                       V3DistanceBetween2Points(&(f->X),&(g->X))<lim)
                indicesface(&indf,&co2,g->misto-1,f->misto-1,i->misto-1);
            }
          }
      }
    }
  }
  
  fprintf(arq, "ply\n");
  fprintf(arq, "format ascii 1.0\n");
  fprintf(arq, "comment author: Greg Turk\n");
  fprintf(arq, "obj_info random information\n");
  fprintf(arq, "element vertex %d\n",co );
  fprintf(arq, "property float x\n");
  fprintf(arq, "property float y\n");
  fprintf(arq, "property float z\n");
  fprintf(arq, "element face %d\n",co2);
  fprintf(arq, "property uchar intensity\n");
  fprintf(arq, "property list uchar int vertex_indices\n");
  fprintf(arq, "end_header\n");

  for (li=0; li<X_MAX[nvi-1]; li++) {
    for (lj=0; lj<Y_MAX[nvi-1]; lj++){
      f=array_orig[nvi-1][li][lj];
      if (f){
        f=array_orig[nvi-1][li][lj];
         fprintf(arq,"%f %f %f\n",f->X.x,f->X.y,f->X.z);
         /*       fprintf(arq,"%f %f %f\n",0.866*f->X.x+0.5*f->X.z,f->X.y,-0.866*f->X.x+0.5*f->X.z);*/
      }
    }
  }
  
  for (li=0; li<co2; li++) {
    fprintf(arq,"4 3 %d %d %d\n",indf[li].i,indf[li].j,indf[li].k);
  }
  
  fclose(arq);

 if ( (arq = fopen(densa[item],"w")) == NULL ) {
    printf("\n Arquivo 'ran' nao foi aberto!! \n\n");
    exit(1);
  }
 
  fprintf(arq, "begin\n");

  for (li=0; li<X_MAX[nvi-1]; li++) {
    for (lj=0; lj<Y_MAX[nvi-1]; lj++){
      f=array_orig[nvi-1][li][lj];
      if (f){
        f=array_orig[nvi-1][li][lj];
        /*fprintf(arq,"v %f %f %f\n",0.866*f->X.x+0.5*f->X.z,f->X.y,-0.866*f->X.x+0.5*f->X.z);*/
         fprintf(arq,"v %f %f %f\n",f->X.x,f->X.y,f->X.z);
      }
    }
  }
  
  for (li=0; li<co2; li++) {
    fprintf(arq,"f %d %d %d\n",indf[li].i+1,indf[li].j+1, indf[li].k+1);
  }
  
  fprintf(arq, "end\n");

  fclose(arq);

  for (li=0; li<X_MAX[nvi-1]; li++) {
    for (lj=0; lj<Y_MAX[nvi-1]; lj++){
      f=array_orig[nvi-1][li][lj];
      if (f)
        f->misto=0;
    }
  }
  free ((char *)indf);

  nfacesdensa[nvi-1]=co2;
  
  printf ("\n Malha Densa -> No Faces : %d | No Vert : %d",co2,co);
  
}

double maior_erro_face (Point3 vert1, Point3 vert2, Point3 vert3){
  int i, j, i0, i2, j0,j2;
  double d, Dp, SomaDp=0.0, a,b,c;
  Img_cart *f;
  Point2 pgon[3], point;
  Vector3 v1,v2;
  Point3 N, aux, vert[3];
  Indice ind;

  
  vert[0]=vert1; vert[1]=vert2; vert[2]=vert3;
         
  /* criando o bounding box de pesquisa;*/

  for (i0 = X_MAX[nvi-1]+1, j0 = Y_MAX[nvi-1]+1,i2 = j2 = -1, i=0; i<3; i++) {
    indice_para_ponto_dist5(vert[i],&ind);
    if (ind.i==-1){
      printf ("\n Nao achou uma amostra correspond. para o vertice");
      return(0);
    }
    pgon[i].x=vert[i].x; pgon[i].y=vert[i].y;
    if (i0 > ind.i) i0 = ind.i;   if (i2 < ind.i) i2 = ind.i;
    if (j0 > ind.j) j0 = ind.j;   if (j2 < ind.j) j2 = ind.j;
  } 
  
  V3Sub(&(vert[1]),&(vert[0]),&v1);
  V3Sub(&(vert[2]),&(vert[0]),&v2);
 V3Cross(&v1,&v2,&N);
  memcpy(&N,(Point3 *)V3Normalize(&N), sizeof(Point3));
  
  d = V3Dot(&(vert[0]),&(N)); 
  if (d){
    SomaDp=-1.0;
    for ( i=i0; i<=i2; i++ ) {
      for ( j = j0; j<=j2; j++ ) {
        f = array_orig[nvi-1][i][j];
        if ( f && !f->misto ){
          point.x=f->X.x; point.y=f->X.y;
          coord_baryc(&(pgon[0]),&(pgon[1]),&(pgon[2]),&point, &a, &b, &c);
          if (a>0 && a<1 && b>0 && b<1 && c>0 && c<1){
            f->misto=1;
            V3Sub(&(f->X), &(vert[0]), &aux);
            Dp=fabs(V3Dot(&(aux),&(N)));
            if (Dp > SomaDp) SomaDp=Dp;
          }
        }
      }
    }
  }else
    printf ("\n Meu vetor normal e zero: ");

  return(SomaDp);

}
double media_erro_face (Point3 vert1, Point3 vert2, Point3 vert3, int *cont){
  int i, j, i0, i2, j0,j2;
  double d, Dp, SomaDp=0.0, a,b,c;
  Img_cart *f;
  Point2 pgon[3], point;
  Vector3 v1,v2;
  Point3 N, aux, vert[3];
  Indice ind;

  
  vert[0]=vert1; vert[1]=vert2; vert[2]=vert3;
         
  /* criando o bounding box de pesquisa;*/

  for (i0 = X_MAX[nvi-1]+1, j0 = Y_MAX[nvi-1]+1,i2 = j2 = -1, i=0; i<3; i++) {
    indice_para_ponto_dist5(vert[i],&ind);
    if (ind.i==-1){
      printf ("\n Nao achou uma amostra correspond. para o vertice");
      return(-1);
    }
    pgon[i].x=vert[i].x; pgon[i].y=vert[i].y;
    if (i0 > ind.i) i0 = ind.i;   if (i2 < ind.i) i2 = ind.i;
    if (j0 > ind.j) j0 = ind.j;   if (j2 < ind.j) j2 = ind.j;
  } 
  
  V3Sub(&(vert[1]),&(vert[0]),&v1);
  V3Sub(&(vert[2]),&(vert[0]),&v2);
 V3Cross(&v1,&v2,&N);
  memcpy(&N,(Point3 *)V3Normalize(&N), sizeof(Point3));
  
  d = V3Dot(&(vert[0]),&(N)); 
  if (d){
    for ( i=i0; i<=i2; i++ ) {
      for ( j = j0; j<=j2; j++ ) {
        f = array_orig[nvi-1][i][j];
        if ( f && !f->misto ){
          point.x=f->X.x; point.y=f->X.y;
          coord_baryc(&(pgon[0]),&(pgon[1]),&(pgon[2]),&point, &a, &b, &c);
          if (a>0 && a<1 && b>0 && b<1 && c>0 && c<1){
            f->misto=1;
            V3Sub(&(f->X), &(vert[0]), &aux);
            Dp=fabs(V3Dot(&(aux),&(N)));
            //            if (Dp > SomaDp) SomaDp=Dp;
            SomaDp+=Dp;
            (*cont)++;
          }
        }
      }
    }
  }else
    printf ("\n Meu vetor normal e zero: ");

  return(SomaDp);

}

double mede_erro_malha (int *nrov, int *nrof, int item){
  double v1, v2, v3;
  int f1, f2, f3, co2=0,k,cont,facescomcorresp;
  char ins[200];
  Point3 *vert;
  Indice3 *fac;
  //  double MAIOR_ERRO=-MAXFLOAT, maior_erro;
  double MAIOR_ERRO=0.0,maior_erro;
  FILE  *arq;
 
  /* Le a estrutura da malha simplificada a partir do arquivo de saida */
  
  vert = (Point3 *)malloc (sizeof(Point3)*3*(*nrof));
  fac = (Indice3 *)malloc (sizeof(Indice3)*(*nrof));

  if ( (arq = fopen(simp[item],"r")) == NULL ) {
    printf("\n Arquivo 'ran' nao foi aberto!! \n\n");
    exit(1);
  }
  
  while (fscanf(arq, "%s", ins) == 1)  {
    if (!strcmp(ins, "v")) {
      fscanf(arq, "%lf %lf %lf", &v1, &v2, &v3);
      vert[*nrov].x=v1; vert[*nrov].y=v2; vert[(*nrov)++].z=v3; 
    }
    else if (!strcmp(ins, "f")) {
      fscanf(arq, "%d %d %d", &f1, &f2, &f3);
      fac[co2].i=f1-1; fac[co2].j=f2-1; fac[co2++].k=f3-1;
    }
   }
  fclose(arq);

  if (*nrof!=co2){
    printf("\n Mudou nrof ");
    (*nrof)=co2;
  }
  //  printf ("\n Calculando erro malha de %d fac", (*nrof));
  printf ("\n ");
  
  for (facescomcorresp=cont=0,k = 0; k<(*nrof); k++ ) {
    /*    maior_erro=maior_erro_face(vert[fac[k].i], vert[fac[k].j],
          vert[fac[k].k]);*/
     maior_erro=media_erro_face(vert[fac[k].i], vert[fac[k].j],
                                vert[fac[k].k],&cont);
    //if (maior_erro > MAIOR_ERRO) MAIOR_ERRO = maior_erro;
     if (maior_erro>=0){
	 MAIOR_ERRO+=maior_erro;
	 facescomcorresp++;
     }
  }
  MAIOR_ERRO/=cont;
  printf ("\n Erro das %d faces de um total de %d faces:  %f ",facescomcorresp,*nrof,MAIOR_ERRO);
  printf ("\n ");

  free ((char *)vert);
  free ((char *)fac);
  
  return (MAIOR_ERRO);
}

static IntPoint2 pesquisaBinaria(int inicio, int fim, int item, double *erro){ 
  int i,j;
  Img_cart *f;
  char qslimcom[200];
  //  double erro;
  IntPoint2 Pivo;

  Pivo.y=0;
  Pivo.x = (inicio + fim) / 2;

  printf ("\n Inicio %d, Fim %d Pivo %d", inicio, fim, Pivo.x);
  printf ("\n");

  sprintf(qslimcom,"./qslim -t %d -O 0 -B 5 -o %s %s",Pivo.x,simp[item],densa[item]);
  if (system(qslimcom))  {
    printf ("\n ERROR: QSlim nao instalado:\n");
    exit (0);
  }
  (*erro)=mede_erro_malha(&Pivo.y, &Pivo.x,item);
  (*erro)=floor((*erro) * 1000 + 0.5) / 1000;

  for ( i=0; i<=X_MAX[nvi-1]; i++ ) {
      for ( j = 0; j<=Y_MAX[nvi-1]; j++ ) {
        f = array_orig[nvi-1][i][j];
        if ( f && f->misto )
          f->misto=0;
      }
  }
  while (inicio < (fim-3) && Tolsimp!=(*erro)){
  
    if (Tolsimp > (*erro))
      return (pesquisaBinaria(inicio, Pivo.x, item, erro));
    else if (Tolsimp < (*erro))
      return(pesquisaBinaria(Pivo.x, fim, item, erro));
  }
  
  return (Pivo) ;
}

void simplifica_malha_densa_smf(void){

  char qslimcom[200];
  int item,nrof,inicio,fim,nrov=0,i=0,j=0,f1,f2,f3;
  IntPoint2 facvert;
  double v1, v2, v3, erro, erromin, erromax; 
  char ins[200];
  FILE *arq;
  Vector3 N,ve1,ve2;
  Img_cart *f;


  item=1; /* Segunda, terceira .... imagem */
  if (nvi==1) /* Primeira imagem */
    item=0;
 
  /* Atencao */

  //Tolsimp=0.1*maxInts[0]; /* otimo para m_reg_curvatura*/

  Tolsimp=0.1*maxInts[0];
  printf ("\n=%1.3f",Tolsimp);
  
  //  Tolsimp=0.1;
  printf ("\n ---------------------------------");
  printf ("\n S: %1.3f",maxInts[0]);
  printf ("\n Tolerancia Solicitada: %1.3f",Tolsimp);
  printf ("\n ---------------------------------");
  printf ("\n");
  
  /* club = 0.15
    frog e lobster = 0.35
     angel = 0.75
  */

  //  decimais=int(pow(10, decimais));
  
  /* 3 casas decimais para Tolsimp2 */
  Tolsimp=floor(Tolsimp * 1000 + 0.5) / 1000; 
  
  inicio = (int)(nfacesdensa[item]*0.004);
  //  inicio = (int)(nfacesdensa[item]*0.001);
  //fim = (int)nfacesdensa[item]*0.6;
  fim = (int)(nfacesdensa[item]*0.5);
  //  inicio=400;
  //fim=600;
  sprintf(qslimcom,"./qslim -t %d -O 0 -B 5 -o %s %s",fim,simp[item],densa[item]);
  if (system(qslimcom))  {
    printf ("\n ERROR: QSlim nao instalado:\n"); 
    return;
  }
  
 erro=mede_erro_malha(&nrov,&fim,item);

  printf ("\n ERRO MINIMO CONSIDERADO -> %1.3f",erro);
  printf ("\n");
  
  facvert.x=fim; facvert.y=nrov;
  
  for ( i=0; i<=X_MAX[nvi-1]; i++ ) {
    for ( j = 0; j<=Y_MAX[nvi-1]; j++ ) {
      f = array_orig[nvi-1][i][j];
      if ( f && f->misto )
        f->misto=0;
    }
  }
  /*
  if (erro < Tolsimp) {
    sprintf(qslimcom,"./qslim -t %d -O 0 -B 5 -o %s %s",inicio,simp[item],densa[item]);
    if (system(qslimcom))  {
      printf ("\n ERROR: QSlim nao instalado:\n");
      return;
    }nrov=0;
    erro=mede_erro_malha(&nrov,&inicio,item );

    printf ("\n ERRO MAXIMO CONSIDERADO -> %1.3f",erro);
    printf ("\n");
    
    facvert.x=inicio; facvert.y=nrov;
    for ( i=0; i<=X_MAX[nvi-1]; i++ ) {
      for ( j = 0; j<=Y_MAX[nvi-1]; j++ ) {
        f = array_orig[nvi-1][i][j];
        if ( f && f->misto )
          f->misto=0;
      }
    }
    if (erro > Tolsimp){
      facvert=pesquisaBinaria(inicio, fim, item, &erro);
    }
  }else
    printf ("\n O erro excedeu o erro minimo considerado");
  printf ("\n");
*/
  
  erros[item]=erro;
  
  /* Atencao ha problemas com a medicao do erro hausdorff */
  
  /* Carrega a estrutura da malha simplificada */

  i=j=0;
  if (item){
    vertices = (Vertice**) realloc(vertices,sizeof(Vertice*)*nvi);
    faces = (Face**) realloc(faces,sizeof(Face*)*nvi);
    nvertfacessimp = (Indice *)realloc (nvertfacessimp, sizeof(Indice)*nvi);
  }
  
  nvertfacessimp[nvi-1].i=facvert.y;
  nvertfacessimp[nvi-1].j=facvert.x;
  faces[nvi-1] = (Face *)malloc(sizeof(Face)*facvert.x);

  vertices[nvi-1] = (Vertice*) malloc(sizeof(Vertice)*facvert.y);
  
  if ( (arq = fopen(simp[item],"r")) == NULL ) {
    printf("\n Arquivo 'ran' nao foi aberto!! \n\n");
    exit(1);
  }

  while (fscanf(arq, "%s", ins) == 1)  {
    if (!strcmp(ins, "v")) {
      fscanf(arq, "%lf %lf %lf", &v1, &v2, &v3);
      vertices[nvi-1][i].X.x=v1;
      vertices[nvi-1][i].X.y=v2; vertices[nvi-1][i].X.z=v3;
      memcpy (&(vertices[nvi-1][i].X_orig),&(vertices[nvi-1][i].X),sizeof(Point3));
      indice_para_ponto_dist5(vertices[nvi-1][i].X,&(vertices[nvi-1][i].indI));
      /*      if (array_orig[nvi-1][vertices[nvi-1][i].indI.i][vertices[nvi-1][i].indI.j])
              array_orig[nvi-1][vertices[nvi-1][i].indI.i][vertices[nvi-1][i].indI.j]->misto=1;*/
      vertices[nvi-1][i].item=0;
      vertices[nvi-1][i++].borda=0;
    }
    else if (!strcmp(ins, "f")) {
      fscanf(arq, "%d %d %d", &f1, &f2, &f3);
      faces[nvi-1][j].item=0; faces[nvi-1][j].borda=0;
      faces[nvi-1][j].ind[0]=f1-1; faces[nvi-1][j].ind[1]=f2-1;
      faces[nvi-1][j].ind[2]=f3-1;
      faces[nvi-1][j].B.x=(vertices[nvi-1][f1-1].X.x+vertices[nvi-1][f2-1].X.x+
                           vertices[nvi-1][f3-1].X.x)/3;
      faces[nvi-1][j].B.y=(vertices[nvi-1][f1-1].X.y+vertices[nvi-1][f2-1].X.y+
                           vertices[nvi-1][f3-1].X.y)/3;
      faces[nvi-1][j].B.z=(vertices[nvi-1][f1-1].X.z+vertices[nvi-1][f2-1].X.z+
                           vertices[nvi-1][f3-1].X.z)/3;
      V3Sub(&(vertices[nvi-1][f2-1]),&(vertices[nvi-1][f1-1]),&ve1);
      V3Sub(&(vertices[nvi-1][f3-1]),&(vertices[nvi-1][f1-1]),&ve2);
      V3Cross(&ve1,&ve2,&N);
      
      memcpy(&(faces[nvi-1][j++].N),(Point3 *)V3Normalize(&N), sizeof(Point3));
    }
  }

  fclose(arq);

  rotula_faces_vert_borda();
 
}

void rotula_faces_vert_borda(){
  int i,j,k,l,a,b,c,d,tem_adj[3];
  double dist;
  
  for (i=0;i<nvertfacessimp[nvi-1].j;i++){
    tem_adj[0]=tem_adj[1]=tem_adj[2]=0;
    for (j=0;j<nvertfacessimp[nvi-1].j;j++){
      if (i!=j){
        for (k=0;k<3;k++){
          a=faces[nvi-1][i].ind[k];
          b=faces[nvi-1][i].ind[(k+1)%3];
          for (l=0;l<3;l++){
            c=faces[nvi-1][j].ind[l];
            d=faces[nvi-1][j].ind[(l+1)%3];
            if ((a==c && b==d) || (a==d && b==c))
              tem_adj[k]=1;
          }
        }
      }
    }
    /* Faces borda com altura < que 2*maxInts[0]*/
    for (k=0;k<3;k++)
      if (!tem_adj[k]){
        if (altura_face(vertices[nvi-1][faces[nvi-1][i].ind[0]].X,
                        vertices[nvi-1][faces[nvi-1][i].ind[1]].X,
                        vertices[nvi-1][faces[nvi-1][i].ind[2]].X)<=maxInts[0]){
          //     faces[nvi-1][i].borda=1;
          //faces[nvi-1][i].item=1;
        }
                vertices[nvi-1][faces[nvi-1][i].ind[k]].borda=1;
          vertices[nvi-1][faces[nvi-1][i].ind[(k+1)%3]].borda=1;
      
      }
  }
}

void gera_mapa_curvatura(void){

  extern int FIMMDL;
  FILE  *arq;
  int i, item;
  double x,y;
  char meshcurvcom[200];
  
  item=1; /* Segunda, terceira .... imagem */
  if (nvi==1) /* Primeira imagem */
    item=0;

  if ( (arq = fopen("saida.ply","w")) == NULL ) {
    printf("\n Arquivo 'ran' nao foi aberto!! \n\n");
    exit(1);
  }
  /* Grava arquivo ply para entrada do programa mesh_curv */
  
  fprintf(arq, "ply\n");  fprintf(arq, "format ascii 1.0\n");
  fprintf(arq, "comment author: Greg Turk\n");
  fprintf(arq, "obj_info random information\n");
  fprintf(arq, "element vertex %d\n",nvertfacessimp[nvi-1].i );
  fprintf(arq, "property float x\n");
  fprintf(arq, "property float y\n");  fprintf(arq, "property float z\n");
  fprintf(arq, "element face %d\n",nvertfacessimp[nvi-1].j);
  fprintf(arq, "property uchar intensity\n");
  fprintf(arq, "property list uchar int vertex_indices\n");
  fprintf(arq, "end_header\n");

  for (i=0; i<nvertfacessimp[nvi-1].i; i++) 
    fprintf(arq,"%lf %lf %lf\n",vertices[nvi-1][i].X.x, vertices[nvi-1][i].X.y,
            vertices[nvi-1][i].X.z);
  for (i=0; i<nvertfacessimp[nvi-1].j; i++) 
    fprintf(arq,"4 3 %d %d %d\n",faces[nvi-1][i].ind[0],faces[nvi-1][i].ind[1],
            faces[nvi-1][i].ind[2]);
  
  fclose(arq); 

  /* Invoca o programa mesh_curv para criar o mapa de curvatura da malha
   simp[item] */
  sprintf(meshcurvcom,"./mesh_curv %s curv 0.1 0.1 teste", "saida.ply");
  if (system(meshcurvcom))  {
    printf ("\n ERROR: mesh_curv nao instalado:\n");
    return;
  }
  
 sprintf(meshcurvcom,"cp saida %s", curv[item]);

 system(meshcurvcom);
 
  if ( (arq = fopen(curv[item],"r")) == NULL ) {
    printf("\n Arquivo 'ran' nao foi aberto!! \n\n");
    exit(1);
  }

  for (i=0; i<nvertfacessimp[nvi-1].i; i++) {
    fscanf(arq,"%lf %lf",&x,&y);
    vertices[nvi-1][i].curvmin=x;
    vertices[nvi-1][i].curvmax=y;
}
    
  fclose(arq);
  FIMMDL=1;
}
