#include <math.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

#include <GL/glut.h>

#include "estrut.h" 
 
#define DISPLAY_LIST 1

/* Global rotation angles and matrix */

char *densa[]={"de1", "de2"};
char *curv[]={"cu1","cu2"};
char *simp[]={"si1","si2"};
char **imagem;
Vertice **vertices; Face **faces;
int nfacesdensa[2];
double erros[2];
Indice *nvertfacessimp;
int nvi=1, *X_MAX, *Y_MAX;
double *raio,*raiomenor,*raiomeio,A;
GLdouble anglex, angley, anglez;
GLdouble rot_matrix[16];
extern int FIMMDL, iteracao;
int ply=0, rif=0, txt=0;
extern double Thresh;      // tolerancia permitida ao erro de reconstrucao
extern Img_cart *array_orig[4][670][670];
extern double zmin;
extern double cx_mod, cy_mod, cz_mod;
extern int componente1, componente2;
Matrix4 R[3];

/* Funcoes de outros modulos */
int gera_frente(void);
void exportTriangles (int);
void exportSmoothTriangles (int);
int adapta_malha_inicial(int);
void getimage(void);
void integracao(int, double, double, double );
int gera_malha_inicial(void);
void mesh_to_image(Matrix4,Point3 ,Point3 *);
/* ---------------------------------------------------------- */
int recalc=0, Obj, qty_vert, qty_vert2, qty_faces, qty_faces2, flag2;
double scale=1.0, tx=0.0, ty=0.0, tz=0.0;

void InitDisplay (void);
void DrawDisplay (void);
int ajusta_modelo(void);
int get_frentes(void);
void le_e_escreve_arquivos(void);

void InitDisplay (void){
  int i, j, k,l,cont=0;
  double escala, x, y, z, r, g, b;
  Point3 aux;
  struct imag_cart *f;
  extern int nro_ve[2];
  extern Matrix4 R0;
  
  glNewList(DISPLAY_LIST, GL_COMPILE); 
  escala = raio[nvi-1];
  // glEnable(GL_DEPTH_TEST);
  /* Create  points_image  */
  glPointSize(4.0);
  glBegin(GL_POINTS);
  for (j=0; j<Y_MAX[nvi-1]; j=j+2){
    for (i=0; i<X_MAX[nvi-1]; i=i+2) {
      f = array_orig[nvi-1][i][j];
      if ( f ) {
        x=(f->X.x-cx_mod)/escala;   y=(f->X.y-cy_mod)/escala;
        z=(f->X.z-cz_mod)/escala;
	//        glColor3f(0.0, 0, 0);
        if (f->misto==1) glColor3f(0.0, 1.0, 1.0);
        if (f->misto==2)  glColor3f(0.0, 1.0, 0.0);
        if (f->misto==3)  glColor3f(0.0, 0.0, 1.0);
        if ( f->misto ){
	     glVertex3d(x,y,z);
        }
      }
    }
  }
  glEnd();
  
  if (nvi>1){  glPointSize(2.0);
  glBegin(GL_POINTS);
  for (j=0; j<Y_MAX[nvi-2]; j=j+2){
    for (i=0; i<X_MAX[nvi-2]; i=i+2) {
      f = array_orig[nvi-2][i][j];
      if ( f ) {
        x=(f->X.x-cx_mod)/(escala);  y=(f->X.y-cy_mod)/(escala);
        z=(f->X.z-cz_mod)/(escala);  
        //glColor3f(0.0, 0.0, 1.0);
        
        if (f->misto==1) glColor3f(0.0, 0.0, 0.0); 
        if (f->misto==2) glColor3f(0.0, 0.0, 1.0); 
        if (f->misto==3) glColor3f(1.0, 0.0, 0.0);
        if (f->misto==4) glColor3f(0.0, 0.0, 1.0);
        if (f->misto==5) glColor3f(1.0, 0.0, 1.0);
        
            if (f->misto)
          glVertex3d(x,y,z);
      }
    }
  }
  glEnd();
  }
   glLineWidth(1);
  /* criando a malha triangulada das malhas 0-nvi-1*/
  glPolygonMode(GL_FRONT, GL_LINE);

  for (k=0; k<nvi; k++){
    r = 1.0 ; g = 0.0 ; b = 0.0;

    /*    if (!k)
       glLineWidth(2);
    else
    glLineWidth(1);*/
    for ( i = 0; i < nvertfacessimp[k].j; i++ ) {
      if ( k%5==0) { r=0.0; g=0.0; b=1.0;}
      if ( k%5==1) { r=0.0; g=0.0; b=1.0;}
      if ( k%5==2) { r=1.0; g=0.0; b=1.0;}
      if ( k%5==3) { r=0.5; g=0.5; b=0.5;}
      if ( k%5==4) { r=1.0; g=1.0; b=0.0;}
      if ( (faces[k][i]).item==1 && faces[k][i].borda) {
        r = 0.0; g = 0.0; b = 0.0;  }
      else if ( faces[k][i].item==2 ) {
        r = 0.0; g = 1.0; b = 0.0;  }
      else if ( faces[k][i].item==3 ) {
        r = 1.0; g = 0.0; b = 0.0;  }
      if (faces[k][i].item)
        glPolygonMode(GL_FRONT, GL_FILL);
      else
        glPolygonMode(GL_FRONT, GL_LINE);
      glColor3f(r, g, b);

      //   if (!faces[k][i].borda
        
      glBegin(GL_POLYGON);

   
      for (j=0; j<3; j++) {   
	aux.x=vertices[k][faces[k][i].ind[j]].normal.x;
        aux.y=vertices[k][faces[k][i].ind[j]].normal.y;
        aux.z=vertices[k][faces[k][i].ind[j]].normal.z;
	//glNormal3f(aux.x,aux.y,aux.z);
        aux.x=vertices[k][faces[k][i].ind[j]].X.x;
        aux.y=vertices[k][faces[k][i].ind[j]].X.y;
        aux.z=vertices[k][faces[k][i].ind[j]].X.z;
        x=(aux.x-cx_mod)/escala;y=(aux.y-cy_mod)/escala;
        z=(aux.z-cz_mod)/escala;
	glEdgeFlag(GL_TRUE);
        glVertex3f(x, y, z);
      }
      glEnd();
      glPointSize(4.0);
      glBegin(GL_POINTS);

      for (j=0; j<3; j++) {
        aux.x=vertices[k][faces[k][i].ind[j]].X.x;
        aux.y=vertices[k][faces[k][i].ind[j]].X.y;
        aux.z=vertices[k][faces[k][i].ind[j]].X.z;
        x=(aux.x-cx_mod)/escala;y=(aux.y-cy_mod)/escala;
        z=(aux.z-cz_mod)/escala;
        glEdgeFlag(GL_TRUE);
	/*if (vertices[k][faces[k][i].ind[j]].item==1){
           glColor3f(1.0,1.0,0.0);
        }else if (vertices[k][faces[k][i].ind[j]].item==2){
          glColor3f(0.0,0.0,0.0);
        }else if (vertices[k][faces[k][i].ind[j]].item==3){
          glColor3f(0.0,0.0,1.0);
        }else if (vertices[k][faces[k][i].ind[j]].item==4){
          glColor3f(0.0,1.0,0.0);
        }
        glVertex3f(x, y, z);*/
      }
      glEnd();
      //      }
    }
  }
  /* Imprime triedro da  malha  nvi-2*/
    glLineWidth(3);
  glPolygonMode(GL_FRONT, GL_LINE);
  if (nvi>1)
    for (k=0; k<nvi; k++){
      if (nro_ve[k]>0)
        for (j=nro_ve[k];j<=nro_ve[k];j++) {
          if (vertices[nvi-2+k][j].indi[0]!=-1){
            if (!k) glColor3f(0.0, 0.0, 0.0);
            else if (k==1) glColor3f(0.7, 0.7, 0.7);
            for (i=0;i<3;i++){
              /* if (!i) glColor3f(0.0, 0.0, 0.0);
              else if (i==1) glColor3f(0.0, 1.0, 0.0);
              else if (i==2) glColor3f(0.0, 1.0, 1.0);
              else glColor3f(1.0, 1.0, 0.0);*/
              
              //              glLineWidth(3);
              glBegin(GL_LINES);
              memcpy (&(aux),&(vertices[nvi-2+k][j].X),sizeof(Point3));
              //              mesh_to_image(R0, aux, &aux);
              x=(aux.x-cx_mod)/escala;
              y=(aux.y-cy_mod)/escala;
              z=(aux.z-cz_mod)/escala;
              glVertex3f(x, y, z);
              memcpy (&(aux),&(vertices[nvi-2+k][vertices[nvi-2+k][j].indi[i]].X),sizeof(Point3));
              //              mesh_to_image(R0, aux, &aux);
              x=(aux.x-cx_mod)/escala;
              y=(aux.y-cy_mod)/escala;
              z=(aux.z-cz_mod)/escala;
              glVertex3f(x, y, z);
              glEnd();
              }
          }
        }
    }
  glPolygonMode(GL_FRONT, GL_LINE);
  glEndList();
}

void myinit(){
  /* Enable depth testing */ 

  anglex=0.0;
  angley=0.0;
  anglez=0.0;
  
  GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
  GLfloat mat_diffuse[] = { 1.0, 1.0, 0.0, 1.0 };
  GLfloat mat_ambient[] = { 1.0, 1.0, 0.0, 1.0 };
  
  GLfloat mat_shininess[] = { 50.0 };
  
  GLfloat light_ambient[] = { 1.0, 1.0, 1.0, 1.0 };
  GLfloat light_diffuse[] = { 1.0, 1.0, 0.0, 1.0 };
  GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };
  
  
  GLfloat light_position[] = { 0.0, 0.0, 3.0, 0.0 };
  glClearColor (1.0, 1.0, 1.0, 1.0); 
  //   glClearDepth(10.0);

  // glShadeModel (GL_FLAT);
  
  glMaterialfv(GL_FRONT, GL_SHININESS, mat_ambient);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
  glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
  glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
  
  
  glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);;
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);
  
  //   glEnable(GL_LIGHTING);
  //   glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);
  
  
  //  glEnable(GL_CULL_FACE);
  //  glCull /* Define projection matrix */
  glMatrixMode(GL_PROJECTION); 
  glLoadIdentity();
  //gluPerspective(45.0, 1.0, 0.5, 10.0);
  glOrtho(-1.1, 1.1, -1.1, 1.1, -12.0, 12.0);
  
  /* Define model viewing matrix */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glGetDoublev(GL_MODELVIEW_MATRIX, rot_matrix);
  glTranslatef(0.0, 0.0, -1.1);
  glEnable(GL_CULL_FACE);
  
  
  /* Initialize rotation angles */
  //anglex=-23;
  //angley=-10.0;
 
} 

void DrawDisplay (void){
  /* Clear frame and z buffers */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  //glutWireSphere (1.0, 20, 16);
  /*
    glPushMatrix();
    glRotatef(anglex, 1.0, 0.0, 0.0);
    glRotatef(angley, 0.0, 1.0, 0.0);
  */
  /* Call previously compiled list */
  glPushMatrix();
  
  glScalef(scale,scale,scale);
  glTranslatef(tx, ty, tz);  
  //glutSolidSphere (1.0, 20, 16);

  glCallList(DISPLAY_LIST);
  glPopMatrix();
  /* Sync graphic drawing requests and swap buffers */
  glFlush();     
  glutSwapBuffers();
}

void ExposeCallback (){
  InitDisplay();
  glutPostRedisplay();  
}

void Special(int key, int x, int y){
  switch (key)   {
  case GLUT_KEY_UP:
    ty=ty+0.15;
    glutPostRedisplay();
    break;
    
  case GLUT_KEY_DOWN:
    ty=ty-0.15;
    glutPostRedisplay();
    break;
    
  case GLUT_KEY_RIGHT:
    tx=tx+0.15;
    glutPostRedisplay();
    break;
    
  case GLUT_KEY_LEFT:
    tx=tx-0.15;
    glutPostRedisplay();
    break;
  }
}

void keyboard(unsigned char key, int x, int y){
  switch (key){
  case 27:
    exit(0);                 break;
  case '+':
    scale+=0.15; InitDisplay(); 
    glutPostRedisplay();
    break;
  case '-':
    scale-=0.15; InitDisplay(); 
    glutPostRedisplay();
    break;
  }
}
/*
void keyboard (unsigned char key, int x, int y){
  char nome[25];
  x=y;
  
  switch (key) {
  case 27:
    exit(0);
  default:{
    glutIdleFunc(NULL);
  }
  }
  // vizualizando o modelo 
  anglex+=0.8;
  angley-=0.8;
  InitDisplay(); 
  glutPostRedisplay(); 
}*/
  
void Idle(void){
  char nome[25];
  int i;
  char res; extern double angx,angy,angz;

 
  printf("\n Deseja integrar outra vista <s/n> ==>");
  scanf("%s", &res);
  printf("\n");
  if (res=='s'){
    nvi++; printf("\n Vista No->%d\n", nvi);
    /* Atencao Copiar os arquivos curv2 a curv1 e simp2 a simp1*/
    /* substituir nfacesdensa2 a nfacesdensa1 */
    getimageint();
    FIMMDL=0;}
  else {
    glutIdleFunc(NULL);
   /* Atencao temos que liberar memoria */
   //  free ((char *)nvertfacessimp);
  
     /*  for (i=0;i<nvi;i++){
    free (vertices[i]);
      free (faces[i]);
  }
  free (vertices);
  free (faces);*/
  }
  /* vizualizando o modelo */
  InitDisplay(); 
  glutPostRedisplay();
}


void mouse (int button, int state, int x, int y){
  static int lastx, lasty;
  int redraw;

  redraw=0;
  if (button == GLUT_LEFT_BUTTON) {
    if (state == -1 && recalc == 1) {
    /* Check for mouse motion with button#1 pressed */
      angley=0.6*(x-lastx);
      anglex=0.6*(y-lasty);
      lastx=x;
      lasty=y;
      redraw=1;
    }
    else if (state == GLUT_DOWN && recalc == 0) {
    lastx=x;
    lasty=y;
    recalc = 1;
    }
    else if (state == GLUT_UP) {
      recalc=0;
    }
  }

  /* Recalc the model viewing matrix if needed */ 
  if (redraw) {
    /* First, apply rotations to our private rotation
       matrix and store it */ 
    glLoadIdentity();
    glRotatef(anglex, 1.0, 0.0, 0.0);
    glRotatef(angley, 0.0, 1.0, 0.0);
    glMultMatrixd(rot_matrix);
    glGetDoublev(GL_MODELVIEW_MATRIX, rot_matrix);
    
    /* Then, use the previously updated matrix to
       build the model view matrix */
    glLoadIdentity();
    //    glTranslatef(0.0, 0.0, -1.5/*-(zmin/rotaio)*/);
    glMultMatrixd(rot_matrix);
    redraw=1;
  }
  
  /* Redisplay widget if needed */
  InitDisplay();
  if (redraw)
     glutPostRedisplay();  
}

void motion (int x, int y){
  mouse(0, -1, x, y);
}

void main_menu(int i){
    switch(i) {
    case 1:
        exit(0);
        break;
    }
}

void grava_menu(int i){
  char nome[16];
  
  switch(i) {
  case 1:
    /*        exportTriangles(Obj);
              exportSmoothTriangles(Obj);*/
    strcpy(nome,"   ");
    strncat(nome,imagem[nvi-1],13);
    nome[0] =  iteracao/100+48;
    nome[1] =  ((iteracao%100)/10)+48;
    nome[2] =  (iteracao%100)%10+48;
    //    tdmObjply(nome,1,&Obj);
    break;
  case 2:
    strcpy(nome,"   ");
    strncat(nome,imagem[nvi-1],13);
    nome[0] =  iteracao/100+48;
    nome[1] =  ((iteracao%100)/10)+48;
    nome[2] =  (iteracao%100)%10+48;
    //tdmObj2off(nome,1,&Obj);
    //    tdmObj2off("saida",1,&Obj);
  }
}

int gravamenu, mainmenu;

void create_menus(void){
    gravamenu = glutCreateMenu(grava_menu);
    glutAddMenuEntry("-----------", 0);
    // glutAddMenuEntry("Pov", 1);
    glutAddMenuEntry("Ply", 1);
    glutAddMenuEntry("Off", 2);
    
    mainmenu = glutCreateMenu(main_menu);

    glutAddMenuEntry("-----------", 0);
    glutAddSubMenu("Gravar", gravamenu);
    glutAddMenuEntry("Quit", 1);

    glutAttachMenu(GLUT_RIGHT_BUTTON);
}

void reshape (int w, int h){
  /* Update viewport dimensions */
  glViewport(0, 0, w, h); 

  /* Change protojection matrix to maintain aspect ratio */
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-1.1, 1.1,-1.1, 1.1, -12.0, 12.0);
  glMatrixMode(GL_MODELVIEW);
  //glLoadIdentity();
}

//void modl3d(int argc, char **argv, int obj)
int main(int argc, char *argv[]) {  

  imagem = (char**) malloc(sizeof(char*));
  imagem[0] = (char*) malloc(30*sizeof(char));
  
  vertices = (Vertice**) malloc(sizeof(Vertice*));
  faces = (Face **)malloc (sizeof(Face*));
  
  nvertfacessimp = (Indice *) malloc (sizeof (Indice));

  X_MAX = (int *) malloc (sizeof(int));
  Y_MAX = (int *) malloc (sizeof(int));
  raio = (double *)malloc (sizeof(double));
  raiomenor = (double *)malloc (sizeof(double));
  raiomeio = (double *)malloc (sizeof(double));
  if ( argc > 1 ){
    strcpy(imagem[0],argv[1]);
    if (strstr (imagem[0], ".ply"))
      ply=1;
    else if (strstr(imagem[0],".rif"))
      rif=1;
    else if (strstr(imagem[0],".txt"))
      txt=1;
    if (!ply && !rif && !txt){
      printf("\n ERRO... Digite o nome da imagem no formato ply, rif ou txt ");
      printf("\n > regvartxt <.ply> | <.rif> | <.txt> \n");
    }
  }else { 
    printf("\n ERRO... Digite o nome da imagem no formato ply, rif ou txt ");
    printf("\n > regvartxt <.ply> | <.rif> | <.txt> \n");
    exit(1);
  } 
  
  R[0].element[0][0] = 1.0; R[0].element[0][1] = 0.0;
  R[0].element[0][2] = 0.0; R[0].element[0][3] = 1.0;
  
  R[0].element[1][0] = 0.0; R[0].element[1][1] = 1.0;
  R[0].element[1][2] = 0.0; R[0].element[1][3] = 1.0;

  R[0].element[2][0] = 0.0; R[0].element[2][1] = 0.0;
  R[0].element[2][2] = 1.0; R[0].element[2][3] = 1.0;
  
  le_e_escreve_arquivos();
  
  glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE);
  // glutInitWindowPosition(200, 0);
  glutInitWindowPosition(350, 0);
  glutInitWindowSize(400, 400); 
  glutInit(&argc, argv);
  glutCreateWindow("Modelo 3D");
  glutDisplayFunc(DrawDisplay);
  glutKeyboardFunc(keyboard);
  glutMouseFunc(mouse);
  glutSpecialFunc(Special);
  glutMotionFunc(motion);
  glutIdleFunc(Idle); 
  
  //glutcmpInit(mouse, motion, 0);
  
  create_menus();
  
  myinit(); InitDisplay(); 
  glutPostRedisplay();
  glutSwapBuffers();
  glutMainLoop();
  return 0;             /* ANSI C requires 5ain to return int. */
}





















